#include <bits/stdc++.h>
using namespace std;

#define endl      '\n'
#define sz(x)     int((x).size())
#define all(x)    (x).begin(), (x).end()
#define rall(x)   (x).rbegin(), (x).rend()
#define fi        first
#define se        second
#define pb        push_back
using ll = long long;
using pii = pair<int, int>;
 

bool isVowel(char ch){
	return (ch == 'a' || ch == 'e' || ch == 'i' || ch == 'o' || ch == 'u');
}

int countPars(string str){
	str += "h";
	int res = 0;
	for(int i = 0; i < str.size()-1; i++){
		if(isVowel(str[i]) && !isVowel(str[i+1])) res++;
	}
	return res;
}

void solve(){
	int n;
	cin >> n;
	vector< string > str(2+n);
	vector< int > pars(2+n);
	for(int i = 1; i <= n; i++){
		cin >> str[i];
		pars[i] = countPars(str[i]);
	}

	map< ll, ll > pos;
	vector< int > pref(2+n);
	for(int i = 1; i <= n; i++){
		pref[i] = pref[i-1] + pars[i];
		pos[pref[i]]++;
	}

	ll ans = 0;
	for(int i = 0, a, b, c; i <= n; i++){
		a = pos[pref[i]+5];
		b = pos[pref[i]+5+7];
		c = pos[pref[i]+5+7+5];
		ans += a*b*c;
	}

	cout << ans;
}

int32_t main(){
	ios::sync_with_stdio(0), cin.tie(0);
	solve();
	return 0;
}
