﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
//#include "temp.cpp"
#include <cstdio>
using namespace std;

#ifndef ONLINE_JUDGE
#define dbg(x) cerr << #x <<" "; print(x); cerr << endl;
#else
#define dbg(x)
#endif

#define sz(x) (int((x).size()))
#define len(x) (int)x.length()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define pf push_front
#define pb push_back
#define popf pop_front
#define popb pop_back
#define ft front
#define bk back

void print(long long t) { cerr << t; }
void print(int t) { cerr << t; }
void print(string t) { cerr << t; }
void print(char t) { cerr << t; }
void print(double t) { cerr << t; }
void print(unsigned long long t) { cerr << t; }

template <class T, class V> void print(pair <T, V> p);
template <class T> void print(vector <T> v);
template <class T> void print(set <T> v);
template <class T, class V> void print(map <T, V> v);
template <class T> void print(multiset <T> v);
template <class T> void print(T v[], T n) { cerr << "["; for (int i = 0; i < n; i++) { cerr << v[i] << " "; } cerr << "]"; }
template <class T, class V> void print(pair <T, V> p) { cerr << "{"; print(p.first); cerr << ","; print(p.second); cerr << "}"; }
template <class T> void print(vector <T> v) { cerr << "[ "; for (T i : v) { print(i); cerr << " "; } cerr << "]"; }
template <class T> void print(set <T> v) { cerr << "[ "; for (T i : v) { print(i); cerr << " "; } cerr << "]"; }
template <class T> void print(multiset <T> v) { cerr << "[ "; for (T i : v) { print(i); cerr << " "; } cerr << "]"; }
template <class T, class V> void print(map <T, V> v) { cerr << "[ "; for (auto i : v) { print(i); cerr << " "; } cerr << "]"; }
typedef long long ll;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
#define nl '\n'


// lowest / (1 << 17) >= 1e5 / (1 << 18) >= 2e5
void fastIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
}
// file in/out
void setIO(string str = "") {
    fastIO();

    if (str != "") {
        freopen((str + ".in").c_str(), "r", stdin);
        freopen((str + ".out").c_str(), "w", stdout);
    }
}
// Indexed Set
template <class T> using Tree = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const long long N = 1e9;
int g[2] = { 1, 2 };
vector< pair<long long, long long> > p;

long long gcd(long long a, long long b) {
    if (b == 0) return a;
    p.pb({ g[0], -(a / b) });
    swap(g[0], g[1]);
    return gcd(b, a % b);
}

int main() {
    long long a, b; cin >> a >> b;

    if (a < b) {
        swap(a, b);
        swap(g[0], g[1]);
    }

    if (a < 0 && b < 0) {
        p.pb({ g[0], -1 });
        a += -b;
    }

    if (a > 0 && b < 0) {
        p.pb({ g[1], ((abs(b) + a - 1) / a) });
        b += ((abs(b) + a - 1) / a) * a;
    }

    gcd(a, b);

    int len = (int)p.size();
    cout << len << endl;
    assert(len <= 50);
    for (int i = 0; i < len; i++) {
        cout << p[i].first << " " << p[i].second << endl;
    }

    return 0;
}