#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <stack>

using namespace std;

const int N = 200003;
const int mod = 1000000007;
const int lg = 22;


int n, m, x;
int a[N], dp[N];
vector<int> g[N];

void dijkstra()
{
    priority_queue<pair<int, int>> q;
    dp[1] = a[1] < x ? x : (x / 2);
    q.push({ dp[1], 1 });
    while (!q.empty())
    {
        int v = q.top().second;
        int nx = q.top().first;
        q.pop();
        for (int to : g[v])
        {
            int na = a[to] < nx ? nx : (nx / 2);
            if (dp[to] < na)
            {
                dp[to] = na;
                q.push({ na, to });
            }
        }
    }
}

void solve()
{
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    cin >> x;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    dijkstra();
    cout << dp[n] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}