#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <stack>

using namespace std;

const int N = 200003;
const int mod = 1000000007;
const int lg = 22;

long long a, b;
int ans = 0;

void solve()
{
    cin >> a >> b;
    vector<pair<int, long long>> v;
    while (a != 0 && b != 0)
    {
        ans++;
        if (abs(a) > abs(b))
        {
            long long k = -a / b;
            long long mn = (long long)mod * mod;
            int t = -1;
            for (int i = -1; i <= 1; i++)
            {
                long long na = a + (k + i) * b;
                if (abs(na) < abs(mn))
                {
                    mn = na;
                    t = i;
                }
            }
            v.push_back({ 1, k + t });
            a = mn;
        }
        else
        {
            long long k = -b / a;
            long long mn = (long long)mod * mod;
            int t = -1;
            for (int i = -1; i <= 1; i++)
            {
                long long na = b + (k + i) * a;
                if (abs(na) < abs(mn))
                {
                    mn = na;
                    t = i;
                }
            }
            v.push_back({ 2, k + t });
            b = mn;
        }
    }
    cout << ans << endl;
    for (auto x : v)
        cout << x.first << ' ' << x.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}