#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e6 + 3e2;

#define MP make_pair

const ll LLINF = 1e18 + 3e2;

pair<int, int> seg[N];

int d(int i, int j){
    if (seg[j].first <= i && i <= seg[j].second) return 0;
    if (i < seg[j].first) return seg[j].first - i;
    return i - seg[j].second;
}

ll t[N];

void build(int v, int tl, int tr){
    if (tl == tr){
        t[v] = 1;
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v + v, tl, tm);
    build(v + v + 1, tm + 1, tr);
    t[v] = min(t[v + v], t[v + v + 1]);
}

int get(int v, int tl, int tr, int l, int r){
    if (l <= tl && tr <= r) return t[v];
    if (tl > r || tr < l) return LLINF;
    int tm = (tl + tr) >> 1;
    return min(get(v + v, tl, tm, l, r), get(v + v + 1, tm + 1, tr, l, r));
}

void solve(){
    int n, m;
    cin >> n >> m;

    vector<vector<ll>> dp(n, vector<ll>(m, LLINF));

    for (int j = 0; j < m; j++){
        int l, r;
        cin >> l >> r;
        seg[j] = MP(l - 1, r - 1);
    }

    for (int i = 0; i < n; i++){
        dp[i][0] = d(i, 0);
    }

    for (int j = 1; j < m; j++){
        for (int i = 0; i < n; i++){
            for (int k = 0; k < n; k++){
                dp[i][j] = min(dp[i][j], dp[k][j - 1] + d(i, j - 1) + d(i, j));
            }
        }
    }

    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            //cout << dp[i][j] << ' ';
        }
        //cout << endl;
    }

    ll ans = LLINF;
    for (int i = 0; i < n; i++){
        ans = min(ans, dp[i][m - 1]);
    }

    cout << ans;

}

int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int TC = 1;
    //cin >> TC;

    for (int tt = 1; tt <= TC; tt++){
        solve();
    }

    return 0;
}
