﻿#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <sstream>

using namespace std;

template <typename T>
string toString(T val)
{
	ostringstream oss;
	oss << val;
	return oss.str();
}

template<typename T>
T fromString(const string& s)
{
	istringstream iss(s);
	T res;
	iss >> res;
	return res;
}

long long foo(long long a) {
	string str = toString(a);

	reverse(str.begin(), str.end());

	return fromString<long long>(str);
}

int main() {
	long long a, b, c, e = 0;
	cin >> a >> b;
	for (long long i = a; i <= b; i++) {
		c = foo(i);
		if ((int)sqrt(c) == sqrt(c) && (int)sqrt(i) == sqrt(i) && i % 10 != 0) {
			e++;
		}
	}
	cout << e;
}