﻿#include <ctime>
#include <random>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(30);
	int n, m, a, b, x;
	cin >> n >> m;
	vector <vector <int>> g(n + 1);
	vector <int> powers(n + 1);
	for (int i = 0; i < m; ++i) {
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	cin >> x;
	for (int i = 1; i <= n; ++i) {
		cin >> powers[i];
	}
	vector <int> d(n + 1, -1);
	set <pair <int, int>> s;
	if (powers[1] < x) {
		d[1] = x;
		s.insert({ x, 1 });
	}
	else {
		d[1] = x / 2;
		s.insert({ x / 2, 1 });
	}
	while (!s.empty()) {
		int u = s.rbegin()->second;
		x = s.rbegin()->first;
		s.erase(*s.rbegin());
		for (auto v : g[u]) {
			if (powers[v] < x && x > d[v]) {
				s.erase({ d[v], v });
				d[v] = x;
				s.insert({ d[v], v });
			}
			else if (powers[v] >= x && x / 2 > d[v]) {
				s.erase({ d[v], v });
				d[v] = x / 2;
				s.insert({ d[v], v });
			}
		}
	}
	cout << d[n];
	return 0;
}