﻿#include <ctime>
#include <random>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

bool is_interesting(ll x) {
	ll n = 0;
	while (x > 0) {
		n = n * 10 + x % 10;
		x /= 10;
	}
	ll t = floor(sqrtl(n));
	return t * t == n;
}


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(30);
	
	ll a, b;
	cin >> a >> b;
	ll cnt = 0;
	for (ll i = ceil(sqrtl(a)); i * i <= b; ++i) {
		if (is_interesting(i * i) && i % 10 != 0) {
			cnt++;
		}
	}
	cout << cnt;
	return 0;
}