#include <iostream>
#include <vector>

using namespace std;

pair<int, int> check_proh(vector < pair<int, int>> proh, int l, int r) {
	int pr = 0;
	for (int i = 0; i < proh.size(); i++) {
		if (proh[i].first == l && proh[i].second == r) {
			l -= 1;
			pr = 1;
			break;
		}
	}
	if (pr) {
		return check_proh(proh, l, r);
	}
	return { l, r };
}

int main() {
	int n, l = 1, r = 1, s, r_proh, l_proh, prohibited = 0;
	pair<int, int> new_lr;
	cin >> n;
	vector<int> answer;
	vector < pair<int, int>> proh;
	while (answer.size() != n) {
		prohibited = 0;
		new_lr = check_proh(proh, l, r);
		if (l != new_lr.first) {
			prohibited = 1;
			l = new_lr.first;
			r = new_lr.second;
		}
		cout << "? " << l << " " << r << "\n";
		cin >> s >> l_proh >> r_proh;
		proh.push_back({ l_proh, r_proh });
		if (prohibited) {
			for (int j = l-1; j < r - 1; j++) {
				s -= answer[j];
			}
			answer.push_back(s);
			l += 1;
		}
		else {
			answer.push_back(s);
		}
		r += 1;
		l += 1;
	}
	cout << "!" << "\n";
	for (int i = 0; i < n; i++) {
		cout << answer[i] << " ";
	}
	return 0;
}