#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

void dfs(vector<int> &e, vector<vector<int>> &list, vector<int> &check, vector<int> &ma, int cur, int prev)
{
	if (cur != 0)
		ma[cur] = max(ma[cur], (ma[prev] > e[cur] ? ma[prev] : (ma[prev] / 2)));
	check[cur] = 1;

	int len = list[cur].size();
	for (int i = 0; i < len; ++i)
	{
		if (check[list[cur][i]] == 0)
			dfs(e, list, check, ma, list[cur][i], cur);
	}
}

int main()
{
	int n = 0;
	int m = 0;
	int k = 0;
	cin >> n >> m;
	vector<vector<int>> list(n);
	vector<int> e(n);
	vector<int> check(n, 0);
	vector<int> ma(n, 0);

	for (int i = 0; i < m; ++i)
	{
		int a = 0;
		int b = 0;
		cin >> a >> b; a--; b--;
		list[a].push_back(b);
		list[b].push_back(a);
	}
	
	cin >> k;
	for (int i = 0; i < n; ++i)
		cin >> e[i];

	check[0] = 1;
	ma[0] = k > e[0] ? k : k / 2;
	dfs(e, list, check, ma, 0, -1);


	cout << ma[n - 1];
	return 0;
}