#include <iostream>
#include <algorithm>
#include <functional>
#include <string>
#include <vector>
#include <deque>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <list>
#include <stack>
#include <array>

#define FAST1 std::ios_base::sync_with_stdio(false);
#define FAST2 std::cin.tie(0);

using ull = unsigned long long;
using ll = long long;
using namespace std;

ll sign(ll a)
{
	if (a > 0)
		return 1;
	if(a < 0)
		return -1;
	return 0;
}

int main()
{
	FAST1;
	FAST2;
	
	int n;
	cin >> n;
	vector<ll> res(n);
	vector<ll> prefs(n + 1);
	prefs[0] = 0;
	vector<vector<bool>> forbs(n);
	for (int i = 0; i < n; ++i)
	{
		forbs[i].assign(n, false);
	}
	std::cout << "? 1 1" << endl;
	ll s;
	int lb, rb;
	cin >> s;
	res[0] = s;
	prefs[1] = s;
	cin >> lb >> rb;
	forbs[rb - 1][lb - 1] = true;
	for (int i = 1; i < n; ++i)
	{
		int lq;
		for (lq = 0; lq < n; ++lq)
			if (!forbs[i][lq]) break;
		std::cout << "? " << lq + 1 << " " << i + 1 << endl;
		cin >> s;
		ll resi = s;
		resi -= (prefs[i] - prefs[lq]);
		res[i] = resi;
		prefs[i + 1] = prefs[i] + resi;
		cin >> lb >> rb;
		forbs[rb - 1][lb - 1] = true;
	}
	std::cout << "!" << endl;
	for (auto x : res)
		std::cout << x << " ";
	return 0;
}