#include <iostream>
#include <algorithm>
#include <functional>
#include <string>
#include <vector>
#include <deque>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <list>
#include <stack>
#include <array>

#define FAST1 std::ios_base::sync_with_stdio(false);
#define FAST2 std::cin.tie(0);

using ull = unsigned long long;
using ll = long long;
using namespace std;

const array<char, 5> vowels = {'a', 'e', 'i', 'o', 'u'};

int syll(string s)
{
	bool prevVow = false;
	int counter = 0;
	for (int i = 0; i < s.length(); ++i)
	{
		if (find(vowels.begin(), vowels.end(), s[i]) != vowels.end())
		{
			if (!prevVow)
				++counter;
			prevVow = true;
		}
		else
			prevVow = false;
	}
	return counter;
}

int main()
{
	FAST1;
	FAST2;
	int n;
	int c=0;
	ll ans=0;
	string word;
	vector<pair<int, int>> dict;
	cin >> n;

	for (int i = 0; i < n; ++i) {
		cin >> word;
		if (syll(word) != 0) {
			dict.push_back(pair<int, int>(c, syll(word)));
			c = 0;
		}
		else {
			c += 1;
		}
	}
	dict.push_back(pair<int, int>(c, 10));
	if (dict.size() < 4) {
		cout << '0' << endl;
	}
	else {
		for (int j = 0; j < dict.size() - 3; ++j) {
			int i = j;
			int x = 0;
			int a = (dict[i].first + 1);
			while (x < 5) {
				x += dict[i].second;
				a *= (dict[i + 1].first + 1);
				i++;
				if (i >= dict.size() - 2) { break; }
			}
			if (x != 5) { continue; }
			x = 0;
			while (x < 7) {
				x += dict[i].second;
				a *= (dict[i + 1].first + 1);
				i++;
				if (i >= dict.size() - 2) { break; }
			}
			if (x != 7) { continue; }
			x = 0;
			while (x < 5) {
				x += dict[i].second;
				a *= (dict[i + 1].first + 1);
				i++;
				if (i >= dict.size() - 2) { break; }
			}
			if (x != 5) { continue; }
			ans += a;

		}
	}
	cout << ans << endl;
	return 0;
}