#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<pair<ll, ll>> w;

bool cmp(const pair<ll, ll>& a, const pair<ll, ll>& b){
      return abs(a.first) < abs(b.first);
}

void eu(ll a, ll b){
      while(a != 0 && b != 0){
            if(abs(a) > abs(b)){
                  ll x = a / b, y = a / b + 1;
                  vector<pair<ll, ll>> t;
                  t.push_back({a - x * b, -x});
                  t.push_back({a + x * b, x});
                  t.push_back({a - (x+1) * b, -(x+1)});
                  t.push_back({a + (x+1) * b, -(x+1)});
                  sort(t.begin(), t.end(), cmp);
                  a = t[0].first;
                  w.emplace_back(1, t[0].second);
            }else{
                  ll x = b / a, y = b / a + 1;
                  vector<pair<ll, ll>> t;
                  t.push_back({b - x * a, -x});
                  t.push_back({b + x * a, x});
                  t.push_back({b - (x+1) * a, -(x+1)});
                  t.push_back({b + (x+1) * a, -(x+1)});
                  sort(t.begin(), t.end(), cmp);
                  b = t[0].first;
                  w.emplace_back(2, t[0].second);
            }
      }
}

void solve(ll a, ll b){
      eu(a, b);
      if(w.size() <= 50)
            return;
      for(ll x = 1; x <= 10; x ++){
            w.clear();
            w.emplace_back(1, x);
            eu(a + x*b, b);
            if(w.size() <= 50)
                  return;
      }
      for(ll x = 1; x <= 10; x ++){
            w.clear();
            w.emplace_back(2, x);
            eu(a, b + x*a);
            if(w.size() <= 50)
                  return;
      }
      for(ll x = 1; x <= 10; x ++){
            w.clear();
            w.emplace_back(1, -x);
            eu(a - x*b, b);
            if(w.size() <= 50)
                  return;
      }
      for(ll x = 1; x <= 10; x ++){
            w.clear();
            w.emplace_back(2, -x);
            eu(a, b - x*a);
            if(w.size() <= 50)
                  return;
      }
}

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      ll a, b;
      cin >> a >> b;
      solve(a, b);
      assert(w.size() <= 50);
      cout << w.size() << "\n";
      for(auto [x, y] : w)
            cout << x << " " << y << "\n";
}
