#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long long ll;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

vector<pair<ll, ll>> w;

bool cmp(const pair<ll, ll>& a, const pair<ll, ll>& b){
      return abs(a.first) < abs(b.first);
}

void eu(ll a, ll b){
      while(a != 0 && b != 0){
            if(abs(a) > abs(b)){
                  ll x = a / b, y = a / b + 1;
                  vector<pair<ll, ll>> t;
                  t.push_back({a - x * b, -x});
                  t.push_back({a + x * b, x});
                  t.push_back({a - (x+1) * b, -(x+1)});
                  t.push_back({a + (x+1) * b, -(x+1)});
                  sort(t.begin(), t.end(), cmp);
                  a = t[0].first;
                  w.emplace_back(1, t[0].second);
            }else{
                  ll x = b / a, y = b / a + 1;
                  vector<pair<ll, ll>> t;
                  t.push_back({b - x * a, -x});
                  t.push_back({b + x * a, x});
                  t.push_back({b - (x+1) * a, -(x+1)});
                  t.push_back({b + (x+1) * a, -(x+1)});
                  sort(t.begin(), t.end(), cmp);
                  b = t[0].first;
                  w.emplace_back(2, t[0].second);
            }
      }
}

const ll M = 1e18;

map<pair<int, int>, int> kl;

void solve(ll a, ll b, int possible){
    //cout << a << ' ' << b << ' ' << possible << endl;
        if(possible < 0 || abs(a) > M || abs(b) > M || kl[{a, b}])
        {
            w.resize(54);
            return;
        }
        kl[{a, b}] = 1;
      eu(a, b);
      if(w.size() <= 50)
            return;
      for(ll x = 1; x <= 12 && abs(a+x*b) <= M; x ++){
            w.clear();
            w.emplace_back(1, x);
            solve(a + x*b, b, possible - 1);
            if(w.size() <= 50)
                  return;
      }
      for(ll x = 1; x <= 12 && abs(b+x*a) <= M; x ++){
            w.clear();
            w.emplace_back(2, x);
            solve(a, b + x*a, possible - 1);
            if(w.size() <= 50)
                  return;
      }
      for(ll x = 1; x <= 12 && abs(a-x*b) <= M; x ++){
            w.clear();
            w.emplace_back(1, -x);
            solve(a - x*b, b, possible - 1);
            if(w.size() <= 50)
                  return;
      }
      for(ll x = 1; x <= 12 && abs(b-x*a) <= M; x ++){
            w.clear();
            w.emplace_back(2, -x);
            solve(a, b - x*a, possible - 1);
            if(w.size() <= 50)
                  return;
      }
}

int32_t main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
//      ll a, b;
//      cin >> a >> b;
//      solve(a, b);
//      assert(w.size() <= 50);
//      cout << w.size() << "\n";
//      for(auto [x, y] : w)
//            cout << x << " " << y << "\n";


            ll x, y;
            bool canbe = 0;
            cin >> x >> y;
            w.clear();
            solve(x, y, 50);
            if(w.size() > 50){
                {
                    //cout << "aaa";
                    w.clear();
                    int a = x, b = y;
                    do
                        a -= b;
                    while(a - b > 0);
                    solve(a, b, 49);
                    int sz1 = w.size();
                    if(sz1 <= 49)
                    {
                        //canbe = 1;
                        int a = x, b = y;
                        cout << sz1 + 1 << endl;
                        cout << "1k " << a << ' ' << b << ' ' << (a / b) + 1 << endl;
                        for(int i = 0; i < w.size(); i ++)
                            cout << w[i].first << ' ' << w[i].second << endl;
                        return 0;
                    }
                    w.clear();
                    a = x, b = y;
                    do
                        b -= a;
                    while(b - a > 0);
                    solve(a, b, 49);
                    int sz2 = w.size();
                    if(sz2 <= 49)
                    {
                        //canbe = 1;
                        int a = x, b = y;
                        cout << sz2 + 1 << endl;
                        cout << "2 " << (b / a) + 1 << endl;
                        for(int i = 0; i < w.size(); i ++)
                            cout << w[i].first << ' ' << w[i].second << endl;
                        return 0;
                    }
                    //cout << sz1 << ' ' << sz2 << endl;
                }

            }
            else
            {
                //canbe = 1;
                cout << w.size() << endl;
                for(int i = 0; i < w.size(); i ++)
                    cout << w[i].first << ' ' << w[i].second << endl;
            }


}
//574483078683729026 333294816757630494
