#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

map<pair<int, int>, bool> bans;

ll ask(int l, int r)  {
    cout << "? " << l + 1 << " " << r << endl;
    ll res; int lb, rb;
    cin >> res >> lb >> rb;
    lb--;
    bans[{lb, rb}] = true;
    return res;
}

void solve() {
    int n; cin >> n;
    vector<ll> a(n);
    vector<ll> pref(n);
    for (int i = 0; i < n; ++i) {
        int j = i;
        while (bans[{j, i + 1}]) {
            j--;
        }
        pref[i] = ask(j, i + 1) + (j > 0 ? pref[j - 1] : 0);
    }
    cout << "!\n";
    for (int i = 0; i < n; ++i) {
        cout << pref[i] - (i > 0 ? pref[i - 1] : 0) << " ";
    }
    cout << endl;
}

int main() {
    // ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    // freopen("../A.in", "r", stdin);
    // freopen("A.out", "w", stdout);
#endif
    solve();
    return 0;
}
