#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#include <iomanip>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<vector<pair<ll, char>>> graph_t;

const ll INF = 1e18;


void gcd(ll a, ll b, vector<pair<ll, ll>>& ans) {
    while (a && b) {
        if (a > b) {
            ans.push_back({1, -a / b});
            a %= b;
        } else {
            ans.push_back({2, -b / a});
            b %= a;
        }
    }
}


void solve() {
    ll x, y;
    cin >> x >> y;
    vector<pair<ll, ll>> ans;
    if (y < 0 && x < 0) {
    } else if (x < 0) {
        ll k = (abs(x) + y - 1) / y;
        x += y * k;
        ans.push_back({1, k});
    } else if (y < 0) {
        ll k = (abs(y) + x - 1) / x;
        y += x * k;
        ans.push_back({2, k});
    }
    gcd(abs(x), abs(y), ans);
    cout << ans.size() << '\n';
    for (auto& x : ans) {
        cout << x.first << ' ' << x.second << '\n';
    }
}


int main() {
    solve();
    return 0;
}
