#include <bits/stdc++.h>

using namespace std;
using str = string;
using ll = long long;
using ld = long double;
template <typename T> using vec = vector<T>;
template <typename A, typename B> using pr = pair<A, B>;

#define x first
#define y second
#define mp make_pair
#define pb push_back
#define pf push_front
#define sz(x) (ll) x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define clz(x) __builtin_clz(x)
#define ctz(x) __builtin_ctz(x)
#define popcount(x) __builtin_popcount(x)

#define endl '\n'

struct Solver
{
    void run()
    {
        int n, a, b;
        cin >> n >> a >> b;

        vec<ll> a1(n);
        for(int i = 0; i < n; i++)
            cin >> a1[i];

        vec<ll> a2(n);
        for(int i = 0; i < n; i++)
            cin >> a2[i];

        using pi = pr<ll, int>;

        vec<pi> off(n);
        for(int i = 0; i < n; i++)
        {
            off[i].x = abs(a1[i] - a2[i]);
            off[i].y = i;
        }

        auto cmp = [](pi c, pi d)
        {
            return c.x < d.x;
        };

        sort(all(off), cmp);

        vec<int> color(n), ab(n);
        int ca = 0, cb = 0;
        for(int i = 0; i < n; i++)
        {
            if(a1[i] > a2[i])
            {
                ca++;
                color[i] = 1;
                ab[i] = a1[i];
            }
            else
            {
                cb++;
                color[i] = 2;
                ab[i] = a2[i];
            }
        }

        for(int i = 0; i < n && ca < a; i++)
        {
            int v = off[i].y;
            if(color[v] == 2)
            {
                color[v] = 1;
                ab[v] = a1[v];
                ca++;
                cb--;
            }
        }

        for(int i = 0; i < n && cb < b; i++)
        {
            int v = off[i].y;
            if(color[v] == 1)
            {
                color[v] = 2;
                ab[v] = a2[v];
                cb++;
                ca--;
            }
        }

        cout << accumulate(all(ab), 0) << endl;
        for(auto i : color)
            cout << (i == 2 ? 'P' : 'T') << ' ';
    }
};

void boost()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

int main()
{
    boost();

    int t = 1;
    // cin >> t;

    while(t--)
    {
        Solver s;
        s.run();
    }
}
