def createList(graph, n=None, m=None, isOrientated=False):
    W = [set() for i in range(n)]
    for i in range(m):
        u = graph[i][0]
        v = graph[i][1]
        W[u-1].add(v)
        if not isOrientated:
            W[v-1].add(u)
    return W
    
def fight(clones, droids):
    if clones > droids:
        return clones
    else:
        clones = int(clones / 2)
        if clones != 0:
            return clones
        else:
            return False

def scan(room, adj, droids_list):
    avail = list(adj[room-1])
    dr = list()
    for i in avail:
        dr.append(droids_list[i-1])
    return droids_list.index(min(dr))+1

n, m = map(int, input().split())
graph = list()
room = 1
for _ in range(m):
    graph.append(list(map(int, input().split())))
num_of_clones = int(input())
num_of_droids = list(map(int, input().split()))
adj = createList(graph, n, m)
num_of_clones = fight(num_of_clones, num_of_droids[room-1])
if not num_of_clones:
    num_of_clones = 0
else:
    while room != n:
        new_room = scan(room, adj, num_of_droids)
        num_of_clones = fight(num_of_clones, num_of_droids[new_room-1])
        if not num_of_clones:
            num_of_clones = 0
            break
        else:
            room = new_room
print(num_of_clones)