#include <bits/stdc++.h>
using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using ll = long long;

void solve() {
    int n;
    cin >> n;
    if (n == 1) {
        cout << "1\n";
        return;
    }
    vector<int> s(n), v(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i] >> v[i];
    }
    int ans = 2;
    for (int i = 0; i < n; i++) {
        map<pair<double, double>, int> mp;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            double k = (v[j] - v[i]) / (double)(j - i);
            double b = (s[j] - s[i]) / (double)(j - i);
            mp[{k, b}]++;
        }
        map<pair<double, double>, int> mp2;
        for (auto [p1, x] : mp) {
            ans = max(x + 1, ans);
            auto [k1, b1] = p1;
            for (auto [p2, y] : mp) {
                if (p1 == p2) continue;
                auto [k2, b2] = p2;
                double k = k1 - k2;
                double b = b2 - b1;
                if (k != 0) {
                    double z = b / k;
                    double h = b1 + z * k1;
                    if (z >= 0) mp2[{z, h}] += x;
                }
            }
        }
        for (auto [p, x] : mp2) {
            ans = max(ans, x + 1);
        }
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
