#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#define forall(i, x) for(auto& i: x)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define mp make_pair
#define f first
#define s second

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const ll inf = 9e18;

ll n, m, x;
vector < vector < ll > > g;
vector < ll > a, d;
set < pair < ll, ll > > st;

void dijkstra()
{
    if (a[0]>=x) {
        d[0] = x - (x / 2);
    }
    else d[0]=0;
   // cout<<d[0]<<"\n";
    st.insert(make_pair(d[0], 0));

    while (!st.empty())
    {
        auto [l, pos]=*st.begin();
        st.erase(*st.begin());
        for (auto to: g[pos])
        {
            ll t=0;
            if (a[to]>=x-d[pos])
                t=x-d[pos]-(x-d[pos])/2;
            if (d[to]>t+d[pos])
            {
                d[to]=t+d[pos];
                st.insert(make_pair(d[to], to));
            }
        }
    }
}

void solve(){
    cin>>n>>m;
    g.resize(n);
    a.resize(n);
    d.resize(n, inf);
    for (ll i=0; i<m; i++)
    {
        ll u, v;
        cin>>u>>v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    cin>>x;
    for (ll i=0; i<n; i++)
        cin>>a[i];
    dijkstra();
    cout<<x-d[n-1]<<"\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}
/*
 4 4
 1 2
 1 3
 2 4
 3 4
 7
 10 2 3 1

 4 4
 1 2
 1 3
 2 4
 3 4
 7
 10 3 3 1
 */