#include <unordered_set>
#include <unordered_map>
//#include <ext/rope>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <chrono>
#include <string>
#include <vector>
#include <bitset>
#include <cstdio>
#include <random>
#include <stack>
#include <cmath>
#include <queue>
#include <ctime>
#include <map>
#include <set>

//using namespace __gnu_cxx;
using namespace std;

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

typedef long long ll;   
typedef long double ld;
typedef pair <int, int> ii;
typedef pair <ll, ll> dl;
typedef vector <vector <int> > graph;

#define pb push_back
#define eb emplace_back 
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()
 
const int INF = 1e9;
const ld EPS = 1e-8;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2 * 1e5;

#define fast() ios_base::sync_with_stdio(0); cin.tie(0)

vector<int> words;
int pref[101000];

int main() {
    fast();
    
    #ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
   
    set<char> cont = {'a', 'e', 'i', 'o', 'u'};
    int n;
    cin >> n;

    words.resize(n + 1, 0);

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < s.size(); j++) {
            if ((cont.count(s[j]) && (j != 0 && !cont.count(s[j - 1]))) || (j == 0 && cont.count(s[j]))) {
                words[i + 1]++;
            }
        }
    }
    for (int i = 1; i <= n; i++)
        pref[i] = pref[i - 1] + words[i];
    int cnt = 0;
    for (int i = 3; i <= n; i++){
        int uk = i;
        int l = 0, r = uk;
        while (r - l > 1){
            int mid = (l + r) / 2;
            if (pref[uk] - pref[mid - 1] <= 5)
                r = mid;
            else
                l = mid;
        }
        if (pref[uk] - pref[r - 1] != 5)
            continue;
        uk = r - 1;
        l = 0, r = uk;
        while (r - l > 1){
            int mid = (l + r) / 2;
            if (pref[uk] - pref[mid - 1] <= 7)
                r = mid;
            else
                l = mid;
        }
        if (pref[uk] - pref[r - 1] != 7)
            continue;
        uk = r - 1;
        l = 0, r = uk;
        while (r - l > 1){
            int mid = (l + r) / 2;
            if (pref[uk] - pref[mid - 1] <= 5)
                r = mid;
            else
                l = mid;
        }
        if (pref[uk] - pref[r - 1] != 5)
            continue;
        cnt++;
 
    }
    cout << cnt << '\n';
    
    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif 
    return 0;
}