#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18 + 7;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int x;
    cin >> x;
    vector<int> a(n);
    for (auto &x : a) cin >> x;

    vector<int> d(n);
    set<pair<int, int>> st;
    d[0] = (x > a[0] ? x : x / 2);
    st.insert({-d[0], 0});
    while (!st.empty()) {
        auto [kek, v] = *st.begin();
        st.erase(st.begin());
        for (auto &u : g[v]) {
            int dst = (d[v] > a[u] ? d[v] : d[v] / 2);
            if (d[u] < dst) {
                st.erase({-d[u], u});
                d[u] = dst;
                st.insert({-d[u], u});
            }
        }
    }

    cout << d[n - 1];
}

signed main() {
    fast();
    solve();
    return 0;
}
