#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <random>
#include <functional>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

mt19937_64 rng(1337);

//void kukarek() {
//    int a = rng() % INF + 1;
//    int b = rng() % INF + 1;
//}

void solve() {
    int a, b;
    cin >> a >> b;

    if (a == 0 || b == 0) {
        cout << 0;
        return;
    }
    vector<pair<int, int>> res;

//    function<void(int, int)> get = [&] (int a, int b) {
//        if (a == 0 || b == 0) return;
//        if (a < 0 && b < 0) {
//            if (a)
//        }
//    };

    auto add = [&] (int type, int k) {
        if (type == 1) {
            a += k * b;
        } else {
            b += k * a;
        }
        res.emplace_back(type, k);
        assert(abs(a) <= INF);
        assert(abs(b) <= INF);
    };

    while (a && b) {
        if (a < 0 && b < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k - 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k - 1);
                }
            }
        } else if (a < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k + 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k + 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k - 1);
                }
            }
        } else if (b < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k - 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k + 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k + 1);
                }
            }
        } else {
            if (a > b) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k - 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k - 1);
                }
            }
        }
    }

    assert((int) res.size() <= 50);

    cout << (int) res.size() << '\n';
    for (auto &[a, b] : res) cout << a << ' ' << b << '\n';
}

signed main() {
    fast();
    solve();
    return 0;
}
