#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using str = string;
using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;

vector<pair<int, ll>> gg[maxN];
ll p[maxN];

void dfs(int v) {
    for(auto &[u, w] : gg[v]) {
        p[u] = p[v] + w;
        dfs(u);
    }
}

void solve() {
    int n; cin >> n;
    vector<set<int>> g(n + 1);
    auto ask = [&] (int l, int r) {
        cout << "? " << l << ' ' << r << endl;
        int zl, zr;
        ll s; cin >> s >> zl >> zr;
        zl--;
        g[zl].insert(zr);
        g[zr].insert(zl);
        return s;
    };
    for(int i = 1; i <= n; ++i) {
        int j = 0;
        while(g[i].count(j)) j++;
        assert(j < i);
        ll s = ask(j + 1, i);
        gg[j].push_back({i, s});
    }
    dfs(0);
    cout << "!" << endl;
    rep(i, n) cout << p[i + 1] - p[i] << ' ';
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}