#include <map>
#include <set>
#include <cmath>
#include <deque>
#include <bitset>
#include <random>
#include <string>
#include <vector>
#include <complex>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
#include <cassert>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  vector<int> A(n);
  vector<int> pref_sum(n + 1);
  for (int i = 0; i < n; ++i) {
      int cur = 0;
      string s;
      cin >> s;
      bool pr = false;
      for (char c : s) {
          bool ok = c == 'a' || c == 'e' || c == 'u' || c == 'i' || c == 'o';
          if (ok && !pr)
              ++cur;
          pr = ok;
      }
      A[i] = cur;
      pref_sum[i + 1] = pref_sum[i] + A[i];
  }
  int j1 = 0, j2 = 0, j3 = 0;
  int ans = 0;
  for (int i = 0; i < n; ++i) {
      while (j1 < n && pref_sum[j1] < pref_sum[i] + 5)
          ++j1;
      while (j2 < n && pref_sum[j2] < pref_sum[i] + 12)
          ++j2;
      while (j3 < n && pref_sum[j3] < pref_sum[i] + 17)
          ++j3;
      ans += pref_sum[j1] == pref_sum[i] + 5 && pref_sum[j2] == pref_sum[i] + 12 && pref_sum[j3] == pref_sum[i] + 17;
  }
  cout << ans << '\n';
  return 0;
}
