package com.company;

import java.util.Scanner;

public class Main {

    static long f(long n) {
        long res = 0;
        while (n > 0) {
            long a = n % 10;
            res *= 10;
            res += a;
            n /= 10;
        }
        return res;
    }

    static boolean isSquare(long n) {
        return ((long) Math.sqrt(n)) * ((long) Math.sqrt(n)) == n;
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        long A = s.nextInt();
        long B = s.nextInt();
        long nearestSquareToA = A;
        long nearestSquareToB = B;

        while(!isSquare(nearestSquareToA)){
            nearestSquareToA++;
        }
        while(!isSquare(nearestSquareToB)){
            nearestSquareToB--;
        }

       // System.out.println(nearestSquareToA);
        //System.out.println(nearestSquareToB);


        long res = 0;
        for (long i = nearestSquareToA; i <= nearestSquareToB; i++) {
            if (isSquare(i)){
                if (i % 10 != 0 && isSquare(f(i))) {
                    res++;
                }
            }
        }
        System.out.println(res);
    }
}
