#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <queue>
#include <deque>
#include <ctime>
#include <chrono>
#include <random>
#include <bitset>
#include <stack>
#include <cstring>
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define F first
#define S second
#define pq priority_queue
#define umap unordered_map
#define uset unordered_set
#define pb push_back
#define sqr(x) ((x)*(x))
#define fill(v,n) for(int qqq=0;qqq<n;qqq++)cin>>v[qqq]
#define seed (myclock::now() - beginning).count()
#define mod 1000000007
#define eps 1e-7
#define BIL 1000000000ll
#define INF sqr(2 * BIL)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ull, ull> pull;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef chrono::high_resolution_clock myclock;

int main() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> g(n);
	vector<int> dp(n, 0), droids(n);
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[--u].push_back(--v);
		g[v].push_back(u);
	}
	cin >> dp[0];
	for (int i = 0; i < n; i++)
		cin >> droids[i];
	if (droids[0] >= dp[0])
		dp[0] /= 2;
	priority_queue<pii> q;
	q.push({ dp[0], 0 });
	while (!empty(q)) {
		auto [d, v] = q.top();
		q.pop();
		if (d < dp[v])
			continue;
		for (int to : g[v]) {
			if (dp[to] < dp[v] && droids[to] < dp[v]) {
				dp[to] = dp[v];
				q.push({dp[to], to});
			}
			if (dp[to] < dp[v] / 2) {
				dp[to] = dp[v] / 2;
				q.push({ dp[to], to });
			}
		}
	}
	cout << dp[n - 1];
}