#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
//using namespace __gnu_pbds;
#define endl '\n'
#define int long long
typedef pair<int, int> ipair;
//typedef tree<ipair, null_type, less<ipair>, rb_tree_tag, tree_order_statistics_node_update> treap;

const int MAXM = 1001000;
const int MAXN = MAXM;
const int INF = 1e16;

#define ls(id) (id << 1 | 1)
#define rs(id) ((id << 1) + 2)

int n, m;
int arr[MAXM], len[MAXM], dp[2][MAXN], tr[MAXN << 2];

void build() {
	fill(*dp, *dp + n, INF);
	for (int i = 0; i < n; ++i)
		if (i + *len <= n)
			dp[1][i] = abs(*arr - i);
	/*
	cerr << "arr: ";
	for (int i = 0; i < m; ++i)
		cerr << arr[i] << ' ';
	cerr << endl << "len: ";
	for (int i = 0; i < m; ++i)
		cerr << len[i] << ' ';
	cerr << endl;*/
}

void build(int id, int l, int r) {
	if (r - l == 1) {
		tr[id] = dp[0][l];
		return;
	}
	int mid = (l + r) >> 1;
	build(ls(id), l, mid);
	build(rs(id), mid, r);
	tr[id] = min(tr[ls(id)], tr[rs(id)]);
}

int query(int id, int l, int r, int ql, int qr) {
	if (qr <= l || r <= ql) return INF;
	if (ql <= l && r <= qr) return tr[id];
	int mid = (l + r) >> 1;
	int s1 = query(ls(id), l, mid, ql, qr);
	int s2 = query(rs(id), mid, r, ql, qr);
	return min(s1, s2);
}

/*
int query(int l, int r) {
	int ans = INF;
	for (int i = l; i < r; ++i)
		ans = min(ans, dp[0][i]);
	return ans;
}*/

int solve() {
	for (int j = 1; j < m; ++j) {
		copy(dp[1], dp[1] + n, *dp);
		fill(tr, tr + (n << 2), INF);
		build(0, 0, n);
		for (int i = 0; i < n; ++i) {
			int l = max(0LL, i - len[j - 1] + 1);
			int r = min(n - len[j - 1], i + len[j] - 1);
		//	cerr << "j, i, l, r: " << j << ' ' << i << ' ' << l << ' ' << r << endl;
			dp[1][i] = query(0, 0, n, l, ++r) + abs(arr[j] - i);
		}
	}
	/*
	for (int j = 0; j < 2; ++j) {
		for (int i = 0; i < n; ++i)
			cerr << dp[j][i] << ' ';
		cerr << endl;
	}*/
	return *min_element(dp[1], dp[1] + n);
}

int32_t main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n >> m;
	for (int j = 0; j < m; ++j) {
		int jl, jr; cin >> jl >> jr, --jl;
		arr[j] = jl;
		len[j] = jr - jl;
	}
	build();
	cout << solve() << endl;
}
