#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    if (k > min(n, m)) {
        cout << "Impossible" << en;
        return;
    }
    vector<vector<int>> a(n, vector<int> (m, 0));
    for (int i = 0; i < k; ++i) {
        a[i][i] = 1;
    }
    cout << "Possible" << en;
    for (auto &i: a) {
        for (auto j: i) {
            cout << (j ? '*' : '.');
        }
        cout << en;
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}