#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
//#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

ll ask(int l, int r, int& l1, int& r1) {
    cout << "? " << l << " " << r << endl;
    ll res = 0;
    cin >> res >> l1 >> r1;
    return res;
}

void answer(vector<ll>& a) {
    cout << "!\n";
    for (ll& i : a)
        cout << i << " ";
    cout << endl;
}

void solve() {
    int n;
    cin >> n;
    vector<ll> pr(n + 1);
    pr[0] = 0;
    vector<ll> a(n);
    vector<set<int>> den(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            if (den[i].count(j)) continue;
            int l1, r1;
            ll res = ask(j + 1, i + 1, l1, r1);
            a[i] = res - (pr[i] - pr[j]);
            den[r1 - 1].emplace(l1 - 1);
            pr[i + 1] = pr[i] + a[i];
            break;
        }
    }
    answer(a);
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
#endif
    solve();
    return 0;
}