#define _CRT_SECURE_NO_WARNINGS

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <deque>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#/*kek, that works*/pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "-->"; cerr.flush()

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)3e5 + 5;
const ll mod = (ll)998244353;
const ll maxlog = 20;

void operator delete(void* q);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
	//system("pause");
#endif // _DEBUG
	exit(exitCode);
}

vector<pair<ll, ll>> vin, vout;

void qpush(ll x) {
	ll mm = x;
	if (!vin.empty()) mm = min(mm, vin.back().second);
	vin.push_back({ x, mm });
}

void qpop() {
	if (vout.empty()) {
		while (!vin.empty()) {
			ll mm = vin.back().first;
			ll x = mm;
			if (!vout.empty()) mm = min(mm, vout.back().second);
			vout.push_back({ x, mm });
			vin.pop_back();
		}
	}
	vout.pop_back();
}

ll qmin() {
	ll ret = inf;
	if (!vin.empty()) ret = min(ret, vin.back().second);
	if (!vout.empty()) ret = min(ret, vout.back().second);
	return ret;
}

ll n, m;

vector<ll> dp[cst];

ll lef[cst];
ll len[cst];

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> m;
	if (m == 1) {
		cout << 0;
		ex();
	}
	for (ll i = 1; i <= m; i++) {
		dp[i].resize(n + 1, inf);
	}
	for (ll i = 1; i <= m; i++) {
		cin >> lef[i] >> len[i];
		len[i] -= lef[i] - 1;
	}
	for (ll i = 1; i <= n; i++) {
		if (i + len[1] - 1 <= n) {
			dp[1][i] = abs(i - lef[1]);
		}
		else break;
	}
	ll answ = inf;
	for (ll i = 2; i <= m; i++) {
		answ = inf;
		while (vin.size() + vout.size()) qpop();
		for (ll j = 1; j < len[i]; j++) qpush(dp[i - 1][j]);
		for (ll j = 1; j <= n - len[i] + 1; j++) {
			qpush(dp[i - 1][j - 1 + len[i]]);
			if(j > len[i - 1]) qpop();
			dp[i][j] = abs(j - lef[i]) + qmin();
			answ = min(answ, dp[i][j]);
		}
	}
	cout << answ;
	ex();
}

