#include <bits/stdc++.h>
#include <x86intrin.h>
#include <ext/pb_ds/assoc_container.hpp>

// Defines
#define F               first
#define S               second
#define endl            "\n"
#define NO              "NO\n"
#define YES             "YES\n"
#define elif            else if
#define mp              make_pair
#define pp              pop_back
#define pb              push_back
#define int             long long
#define ld              long double
#define lb              lower_bound
#define ub              upper_bound
#define pii             pair<int,int>
#define sz(x)           int32_t(x.size())
#define all(x)          x.begin(),x.end()
#define rall(x)         x.rbegin(),x.rend()
#define pll             pair<long long,long long>
#define FOR(i,a,b)      for(int i = (a); i <= (b); i++)
#define REV(i,a,b)      for(int i = (a); i >= (b); i--)
#define precal(x)       fixed << setprecision(x)
#define IOS             ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
#define FILE            freopen("max.in", "r", stdin);freopen("max.out", "w", stdout)

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

// Constants
const int B = 318;
const int LOG = 23;
const int N = 1e6+23;
const int MOD = 1e9+7;
const long long INF = 2e18+1703;
const int dx[5] = {0,1,-1,0,0};
const int dy[5] = {0,0,0,-1,1};

// Functions
long long bp(long long a,long long b){
    long long res = 1;
    while(b > 0){
        if(b&1)res = (res*a)%MOD, b--;
        a = (a*a)%MOD, b >>= 1;
    }
    return res;
}
bool bit(long long x,int p){
    return (x >> p)&1;
}
long long gcd(long long a,long long b){
    return __gcd(a,b);
}
long long lcm(long long a,long long b){
    return (a*b)/__gcd(a,b);
}
bool prime(long long x){
    if((!(x&1) && x > 2) || (x <= 1))return 0;
    for(long long d = 3; d*d <= x; d += 2){
        if(!(x%d))return 0;
    }
    return 1;
}

/*
    CHECK LIMITS FOR -> N, MOD, INF ;)

    Don't forget this:
    Greedy, Dp, Tree, Dsu, Binary search, Bitmask, Brute Force, Data structures, Sort, Graphs, Games tactics, Graph matchings, Number theory, Shortest paths

    Bit operations:
    1) 1^1 = 0, 0^0 = 0, 1^0 = 1, 0^1 = 0
    2) 1&1 = 1, 0&0 = 0, 1&0 = 0, 0&1 = 0
    3) 1|1 = 1, 0|0 = 0, 1|0 = 1, 0|1 = 1

    Tricks to solve:
    1) Reverse the problem
    2) If it equation try to remake in a better way
    3) Draw some tests and solve them by drawing
    4) Maybe there is a regularity?
    5) Try from the opposite to prove the greediness
*/

int n,m;
void solve() {
    long long i, j, k;
    vector<long long> v;

    v.pb(-1);
    for (i = 1; i <= 500000; i++) {
        if (i % 10 == 0) continue;
        j = i * i;
        k = 0;
        while (j) {
            k *= 10;
            k += j % 10;
            j /= 10;
        }
        if (sqrt(k) == (long long)(sqrt(k)))
            v.push_back(i * i);
    }
    long long a, b, posa = -1, posb = -1;
    cin >> a >> b;
    //for (auto i : v) cout << i << " ";

    for(int i = 0; i < sz(v); ++i){
        if(a <= v[i]){posa = i; break;}
    }
    for(int i = 0; i < sz(v); ++i){
        if(b < v[i]){posb = i; break; }
    }

    //cout << a << " " << b << "\n";
    cout << posb - posa << "\n";
}
int32_t main(){
    IOS;
    int test_cases = 1;// cin >> test_cases;
    while(test_cases--){
        solve();
    }
    return 0;
}
