#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

int main() {
    // ios_base::sync_with_stdio(false);
    // cin.tie(0);
    // cout.tie(0);
    // cout.precision(18);
    // #ifdef HOME_DIDUK001
    // freopen("in", "r", stdin);
    // freopen("out", "w", stdout);
    // #endif

    int n;
    cin >> n;

    vector <ll> pref(n + 1);
    vector <ll> a(n + 1);
    set <pair<ll, ll>> s;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= i; j++) {
            if (s.count({j, i}) == 0) {
                cout << '?' << ' ' << j << ' ' << i << '\n';
                ll kek, lb, rb;
                cin >> kek >> lb >> rb;

                s.insert({lb, rb});

                // cout << "prev: " << pref[i - 1] - pref[j - 1] << '\n';
                a[i] = kek - (pref[i - 1] - pref[j - 1]);
                // cout << "ai: " << a[i] << '\n';
                pref[i] = pref[i - 1] + a[i];
                break;
            }
        }
    }

    // for (int i = 1; i <= n; i++) {
    //     cout << pref[i] << ' ';
    // }
    
    cout << '!' << endl;
    for (int i = 1; i <= n; i++) {
        cout << a[i] << ' ';
    }
    cout << endl;
}