#include <iostream>
#include <vector>
#include <cmath>
#include <math.h>

using namespace std;

int m,n,x;
vector<vector<int>> rooms;
vector<int> droid;

int check_room (int num, int clones, int prev) {
    if (num == n) {
        if (clones <= droid[num-1]) {
            clones = floor(clones/2);
        }
        return clones;
    } else {
        if (clones <= droid[num-1]) {
            clones = floor(clones/2);
            if (clones == 0) {
                return 0;
            }
        }
        vector <int> connected;
        for (int i = 0; i < m; i++) {
            if (rooms[i][0] == num && rooms[i][1] != prev) {
                connected.push_back(rooms[i][1]);
            }   else if (rooms[i][1] == num && rooms[i][0] != prev) {
                connected.push_back(rooms[i][0]);
            }
        }
        if (connected.size() < 1) {
            return clones;
        }
        int variations[connected.size()];
        for (int i = 0; i < connected.size(); i++) {
            variations[i] = check_room(connected[i], clones, num);
        }
        int maximum = 0;
        for (int i = 0; i < connected.size(); i++) {
            if (variations[i] > maximum) {
                maximum = variations[i];
            }
        }
        return maximum;
    }
}


int main() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a,b;
        vector<int> buffer;
        cin >> a >> b;
        buffer.push_back(a);
        buffer.push_back(b);
        rooms.push_back(buffer);
    }
    cin >> x;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        droid.push_back(a);
    }

    int res = check_room(1, x, 0);
    cout << res;

    return 0;
}

