#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
	return 0;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>>g(n);
	for (int i = 0; i < m; i++) {
		int v, u; cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	ll x; cin >> x;
	vector<ll>arr(n);
	for (auto& i : arr)
		cin >> i;
	vector<ll>d(n, -1e18);
	d[0] = (x > arr[0] ? x : x / 2);
	set<pair<ll, int>>q;
	q.insert({ d[0], 0 });
	while (!q.empty()) {
		int v = q.begin()->second;
		q.erase(q.begin());
		for (auto i : g[v]) {
			if (d[i] < (d[v] > arr[i] ? d[v] : d[v] / 2)) {
				q.erase({ d[i], i });
				d[i] = (d[v] > arr[i] ? d[v] : d[v] / 2);
				q.insert({ d[i], i });
			}
		}
	}
	cout << d[n - 1];
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}