#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cmath>
#include <algorithm>
#include <stack>
#include <map>
#include <iomanip>


using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll BASE = 179;
const ld EPS = 0.00000001;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n; cin >> n;
    string gl = "euioa";
    vector <ll> a(n, 0);
    for (ll i = 0; i < n; i++) {
        string s; cin >> s;
        for (ll j = 0; j < s.size(); j++) {
            if (find(gl.begin(), gl.end(), s[j]) != gl.end()) {
                a[i]++;
                while (j < s.size() && find(gl.begin(), gl.end(), s[j]) != gl.end()) j++;
            }
        }
    }
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        ll s = 0, x = i;
        while (x < n && s < 5) {
            s += a[x];
            x++;
        }
        if (s != 5) {
            continue;
        }
        s = 0;
        while (x < n && s < 7) {
            s += a[x];
            x++;
        }
        if (s != 7) {
            continue;
        }
        s = 0;
        while (x < n && s < 5) {
            s += a[x];
            x++;
        }
        if (s != 5) {
            continue;
        }
        ans++;
    }
    cout << ans;
    return 0;
}