#define _CRT_SECURE_NO_WARNINGS
#define _GLIB_CXX_DEBUG
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <iomanip>
#include <sstream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define ff first
#define ss second
//#define endl '\n'

using namespace std;
using ll = long long;
using vi = vector<int>;

template<typename T>
bool rMin(T& x, const T& y)
{
	if (x > y)
	{
		x = y;
		return true;
	}
	return false;
}
template<typename T>
bool rMax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

int x[200001];
int y[200001];

bool used[200001];

void solve()
{
	int n, a, b, p = 0, t = 0, sum = 0;

	cin >> n >> a >> b;

	for (int i = 0; i < n; i++)
	{
		cin >> x[i];
	}

	for (int i = 0; i < n; i++)
	{
		cin >> y[i];
	}

	for (int i = 0; i < n; i++)
	{
		if (x[i] > y[i])
		{
			sum += x[i];
			++t;
			used[i] = true;
		}
		else
		{
			sum += y[i];
			++p;
		}
	}

	vector<pair<int, int>> d;

	if (t < a)
	{
		for (int i = 0; i < n; i++)
		{
			if (!used[i])
			{
				d.pb({ y[i] - x[i], i });
			}
		}

		sort(d.begin(), d.end());

		for (int i = 0; i < a - t; i++)
		{
			sum -= d[i].ff;
			used[d[i].ss] = true;
		}
	}
	else if (p < b)
	{
		for (int i = 0; i < n; i++)
		{
			if (used[i])
			{
				d.pb({ x[i] - y[i], i });
			}
		}

		sort(d.begin(), d.end());

		for (int i = 0; i < a - p; i++)
		{
			sum -= d[i].ff;
			used[d[i].ss] = false;
		}
	}

	cout << sum << endl;

	for (int i = 0; i < n; i++)
	{
		if (used[i])
		{
			cout << "T ";
		}
		else
		{
			cout << "P ";
		}
	}

	cout << endl;
}


int32_t main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(6);

	solve();
	
}