#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0), cout.tie(0);
	
	ll n, x, y; cin >> n >> x >> y;
	
	vector<ll> a(n), b(n), c(n);

	ll sum = 0, X = 0, Y = 0;

	for(ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	
	for(ll i = 0; i < n; i++) {
		cin >> b[i];
		
		if(a[i] > b[i]) {
			sum += a[i];
			c[i] = 0;
			X++;
		}
		else {
			sum += b[i];
			c[i] = 1;
			Y++;
		}
	}
	
	vector<pair<ll, ll>> candidates;
	
	if(X < x) {
		for(ll i = 0; i < n; i++) {
			if(c[i] == 0) {
				candidates.push_back({-200, i});
			}
			else {
				candidates.push_back({a[i] - b[i], i});
			}
		}
	}
	
	if(Y < y) {
		for(ll i = 0; i < n; i++) {
			if(c[i] == 1) {
				candidates.push_back({-200, i});
			}
			else {
				candidates.push_back({b[i] - a[i], i});
			}
		}
	}
	
	sort(candidates.begin(), candidates.end());
	
	while(X < x) {
		ll val = candidates.back().first, pos = candidates.back().second;
		sum += val;
		c[pos] = 0;
		X++;
		candidates.pop_back();
	}
	
	while(Y < y) {
		ll val = candidates.back().first, pos = candidates.back().second;
		sum += val;
		c[pos] = 1;
		Y++;
		candidates.pop_back();
	}
	
	cout << sum << "\n";
	
	for(ll i = 0; i < n; i++) {
		cout << (c[i] == 0 ? "T " : "P ");
	}
	
	cout << endl;
  return 0;
}
