#include <bits/stdc++.h>

using namespace std;

const double EPS = 1e-9;

double x, t;

double eff(double T) {
  if (T >= double(t) / 3.0)
    return 100.0;

  if (T <= double(t) / 6.0)
    return x / (double(t) / 6.0) * T;
  
  double k = double(100 - x) / (double(t) / 6.0);
  double b = x - (t / 6.0) * k;
  return k * T + b;
}

int main() {
  cin >> x >> t;
  
  double l = 0, r = t;
  while (abs(r - l) > EPS) {
    double m1 = l + ((r - l) / 3.0);
    double m2 = r - ((r - l) / 3.0);
    if (eff(t - m1) * m1 < eff(t - m2) * m2) {
      l = m1;
    } else {
      r = m2;
    }
  }
  
  cout << fixed << setprecision(9) << eff(t - l) * l << '\n';
  
  return 0;
}