#include <bits/stdc++.h>
#include <bits/extc++.h>

#define sz(v) int (v.size())
#define ff first
#define int long long
#define err(x) cerr << "["#x"]  " << (x) << "\n"
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << ___ << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (auto ___ = 0; ___ < (n); ++___) cerr << (x)[___] << ", "; cerr << "]\n";}
#define ss second
#define pb push_back
#define all(a) a.begin(),a.end()
typedef long long ll;
typedef long double ld;
using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
const int MOD = 1000000007;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}

template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return a < b ? a = b, true : false;
}

double GetTime() { return clock() / (double) CLOCKS_PER_SEC; };
/// Actual code starts here
int n;
const int N = 100005;
void solve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> graph(n);
    for(ll i = 0; i < m; ++i) {
        ll a, b;
        cin >> a >> b;
        --a;
        --b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    ll x;
    cin >> x;
    vector<ll> a(n);
    for(ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    graph.push_back(vector<ll>(1, 0));
    std::priority_queue<pair<ll, ll>> q;
    q.push({x, n});
    vector<bool> was(n + 1);
    while(!q.empty()) {
        auto [cnt, vert] = q.top();
        q.pop();
        if(!was[vert]) {
            was[vert] = true;
            if(vert == n - 1) {
                cout << cnt;
                return;
            }
            for (ll overt: graph[vert]) {
                ll rcnt = cnt;
                if (cnt <= a[overt]) {
                    rcnt /= 2;
                }
                q.push({rcnt, overt});
            }
        }
    }
    cout << 0;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    freopen("input.txt", "r", stdin);
    int tt = 1;
    //cin >> tt;
    while (tt--)
        solve();
}
