#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <cassert>
#include <cstring>
#include <random>
#include <chrono>
#include <ext/rope>
#include <bitset>

#define sqr(x) ((x) * (x))
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;

template <class T>
using indexed_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
ld Time() { return ld(clock()) / CLOCKS_PER_SEC; }

ll x, t;
const ld eps = 1e-12;

ld f(ld cur) {
    if (cur > ld(t) / 6.0) {
        ld k = (100 - x) / (ld(t) / 6.0);
        ld b = 100 - k * (ld(t) / 3.0);

        return (t - cur) * (k * cur + b);
    }
    else {
        ld k = x / (ld(t) / 6.0);
        return (t - cur) * (k * cur);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    cin >> x >> t;
    ld ans = max(x * (t - (ld(t) / 6.0)), 100 * (t - (ld(t) / 3.0)));

    ld l = 0, r = ld(t) / 6.0;
    while (r - l > eps) {
        ld l1 = (2 * l + r) / 3.0, r1 = (l + 2 * r) / 3.0;
        if (f(l1) > f(r1)) {
            r = r1;
        }
        else {
            l = l1;
        }
    }
    ans = max(ans, f(l));

    l = ld(t) / 6.0, r = ld(t) / 3.0;
    while (r - l > eps) {
        ld l1 = (2 * l + r) / 3.0, r1 = (l + 2 * r) / 3.0;
        if (f(l1) > f(r1)) {
            r = r1;
        }
        else {
            l = l1;
        }
    }
    ans = max(ans, f(l));

    cout << fixed << setprecision(8) << ans;

    return 0;
}