#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {

    int n;
    cin >> n;
    vector<long long> ans(n);
    vector<long long> pref(n);
    vector<unordered_set<int>> banned(n);
    cout << "? 1 1" << endl;
    cin >> ans[0];
    int vall, valr;
    cin >> vall >> valr;
    --vall;
    --valr;
    banned[valr].insert(vall);
    pref[0] = ans[0];
    for (int r = 1; r < n; ++r) {
        int l = 0;
        while (banned[r].find(l) != banned[r].end()) {
            ++l;
        }
        cout << "? " << l + 1 << " " << r + 1 << endl;
        long long val;
        cin >> val;
        ans[r] = val - pref[r - 1] + (l == 0 ? 0ll : pref[l - 1]);
        pref[r] = pref[r - 1] + ans[r];
        cin >> vall >> valr;
        --vall;
        --valr;
        banned[valr].insert(vall);
    }
    cout << "!";
    for (int i = 0; i < n; ++i) {
        cout << " " << ans[i];
    }
    cout << endl;

}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    //cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}