#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool glas(char c) {
    return c == 'a' || c == 'e' || c == 'o' || c == 'i' || c == 'u';
}

void solve() {

    int n;
    cin >> n;
    vector<int> val(n, 0);
    vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        if (glas(s[0])) {
            ++val[i];
        }
        for (int j = 1; j < s.size(); ++j) {
            if (glas(s[j]) && !glas(s[j - 1])) {
                ++val[i];
            }
        }
    }
    pref[0] = 0;
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + val[i - 1];
    }
    vector<int> prev5(n + 1, -1), prev7(n + 1, -1);
    for (int i = 1; i <= n; ++i) {
        for (int j = i - 1; j >= 0 && pref[i] - pref[j] <= 7; --j) {
            if (pref[i] - pref[j] == 5) {
                prev5[i] = j;
            }
            else if (pref[i] - pref[j] == 7) {
                prev7[i] = j;
            }
        }
    }
    int ans = 0;
    for (int r = 1; r <= n; ++r) {
        if (prev5[r] != -1) {
            int mr = prev5[r];
            if (prev7[mr] != -1) {
                int ml = prev7[mr];
                if (prev5[ml] != -1) {
                    ++ans;
                }
            }
        }
    }
    cout << ans << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}