#include <bits/stdc++.h>

#define pb push_back
#define all(v) v.begin(),v.end()
#define ff first
#define ss second

using namespace std;

typedef long long ll;
typedef pair<long long, long long> pll;
typedef pair < int, int > pii;
typedef vector<int> vi;
typedef vector<long long> vll;

const int N = 1e5 + 123;
const ll mod = 1e9 + 7;

void solve() {
	int n, m;
	cin >> n >> m;
	int l[m], r[m];
	for(int i = 0; i < m; i++) {
		cin >> l[i] >> r[i];
		l[i]--, r[i]--;
	}
	int dp[m][n];
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) dp[j][i] = INT_MAX;
	}
	for(int i = 0; i < n - (r[0] - l[0]); i++) dp[0][i] = abs(i - l[0]);
	int ans = INT_MAX;
	for(int i = 1; i < m; i++) {
		stack<int> s;
		int tr[n], sz = r[i] - l[i];
		for(int j = n - 1; j >= 0; j--) {
			tr[j] = j;
			while(!s.empty()){
				int t = s.top();
				if(dp[i - 1][j] <= dp[i - 1][t]) {
					tr[j] = tr[t];
					s.pop();
					continue;
				}
				break;
			}
			s.push(j);
		}
		int it = 0;
		for(int o = 0; o < n - sz; o++) {
			while(tr[it] < o + sz || it < o - (r[i - 1] - l[i - 1])) {
				it++;
			}
			dp[i][o] = abs(l[i] - o) + dp[i - 1][it];
		}
	}
	for(int i = 0; i < n; i++) ans = min(ans, dp[m - 1][i]);
	cout << ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
    int times = 1;
	//cin >> times;
    for(int i = 1; i <= times; i++) {
		//cout << "Case " << i << ": ";
		solve();
    }
    return 0;
}
