#include <algorithm>
#include <math.h>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<double> vd;

int reverse(int x)
{
	int a = 0;

	while (x != 0)
	{
		a *= 10;
		a += x % 10;
		x /= 10;
	}
	return a;
}

void solveB()
{
	int a, b;
	cin >> a >> b;

	int min = static_cast<int>(sqrt(a)), max = static_cast<int>(sqrt(b));
	set<int> res;
	for (int i = min; i <= max; i++)
	{
		double x = sqrt(reverse(i * i));
		int y = static_cast<int>(x);
		if (x == y)
			res.insert(y);
	}
	cout << res.size() << '\n';
}

void solveA()
{
	int n, m, k;
	cin >> n >> m >> k;

	if (k > n || k > m)
	{
		cout << "Impossible\n" << endl;
		return;
	}
	cout << "Possible\n";

	for (int i = 0, cnt = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (i == j && cnt < k)
			{
				cout << "*";
				cnt++;
			}
			else
				cout << ".";
		}
		cout << "\n";
	}

}

int main()
{
	solveB();
	return 0;
}