#include <stdio.h>
#include <math.h>

typedef unsigned long long int ULL;

int isSqr( ULL n )
{
  long double s;

  s = sqrt((long double)n);

  return (ULL)s == s;
}

ULL flipNum( ULL n )
{
  ULL res = 0;
  
  if (n != 0)
    while (n >= 1)
    {
      res *= 10;
      res += n % 10;
      n /= 10;
    }
  return res;
}

int main( void )
{
  ULL b, e, i, count;

  scanf("%llu", &b);
  scanf("%llu", &e);

  for (i = b, count = 0; i < e; i++)
    if (isSqr(i) && isSqr(flipNum(i)) && i % 10 != 0)
      count++;/* printf("NUM: %llu\n", i);*/
  printf("%llu", count);
  return 0;
}