#include <iostream>
#include <vector>
#include <deque>

using namespace std;

typedef int ll;

ll inf = 1e9;

int main() {
	ll n, m;
	cin >> n >> m;
	vector<vector<ll>> dpd(m, vector<ll>(n, inf)), dpu(m, vector<ll>(n, inf));
	vector<ll> s(m), t(m);
	vector<ll> a(m);
	for (ll i = 0; i < m; i++) {
		cin >> s[i] >> t[i];
		s[i]--;
		t[i]--;
		a[i] = t[i] - s[i] + 1;
	}
	for (ll i = 0; i < n; i++) {
		if(i + a[0] <=n) dpd[0][i] = abs(s[0] - i);
		if(i >= a[0] - 1) dpu[0][i] = abs(t[0] - i);
	}
	/*
	dpd[i][j] =   abs(s[j] - j)    
	*/
	for (ll i = 1; i < m; i++) {
		deque<ll> d, dm;
		for (ll j = 0; j < min(a[i] + a[i - 1] - 1, n); j++) {
			d.push_back(dpu[i - 1][j]);
			while (!dm.empty() && dm.back() > dpu[i - 1][j]) dm.pop_back();
			dm.push_back(dpu[i - 1][j]);
		}
		dpd[i][0] = dm.front() + abs(s[i]);
		for (ll j = 1; j <= n - a[i]; j++) {
			if (a[i] + a[i - 1] + j - 2 < n) {
				ll u = a[i] + a[i - 1] + j - 2;
				d.push_back(dpu[i - 1][u]);
				while (!dm.empty() && dm.back() > dpu[i - 1][u]) dm.pop_back();
				dm.push_back(dpu[i - 1][u]);
			}
			if (!dm.empty() && dm.front() == d.front()) dm.pop_front();
			d.pop_front();
			dpd[i][j] = dm.front() + abs(s[i] - j);
		}
		for (ll j = 0; j < n; j++) {
			if (j + a[i] - 1 < n) dpu[i][j + a[i] - 1] = dpd[i][j];
		}
	}
	ll ans = inf;
	for (ll i = 0; i < n; i++) ans = min(ans, dpd[m - 1][i]);
	cout << ans;
}