#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <queue>
#include <map>
#include <vector>
#include <climits>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, a, b;

    cin >> n >> a >> b;

    vector<int> th(n);
    vector<int> pr(n);

    for (int i = 0; i < n; ++i)
        cin >> th[i];
    for (int i = 0; i < n; ++i)
        cin >> pr[i];

    int mth = 0;
    int mpr = 0;

    for (int i = 0; i < n; ++i)
        th[i] > pr[i] ? mth++ : mpr++;

    int res = 0;
    string themes;

    if (mth >= a && mpr >= b)
    {
        for (int i = 0; i < n; ++i)
        {
            if (th[i] > pr[i])
            {
                res += th[i];
                themes += "T ";
            }
            else
            {
                res += pr[i];
                themes += "P ";
            }
        }
    }

    if (mth < a && mpr >= b)
    {
        bool made = true;
        vector<int> new_arr;
        for (int i = 0; i < n; ++i)
        {
            if (th[i] < pr[i])
            {
                new_arr.push_back(pr[i] - th[i]);
            }

            else
                new_arr.push_back(101);
        }

        int min_index = 0;
        int min_val = 101;

        for (int i = 0; i < n; i++)
        {
            if (new_arr[i] < min_val)
            {
                min_index = i;
                min_val = new_arr[i];
            }
        }

        for (int i = 0; i < n; ++i)
        {
            if (pr[i] > th[i] && (i != min_index && made == true))
            {
                res += pr[i];
                themes += "P ";
            }

            if (i == min_index)
                made = false;

            else
            {
                res += th[i];
                themes += "T ";
            }
        }
    }

    if (mth >= a && mpr < b)
    {
        bool made = true;
        vector<int> new_arr;
        for (int i = 0; i < n; ++i)
        {
            if (th[i] > pr[i])
            {
                new_arr.push_back(th[i] - pr[i]);
            }

            else
                new_arr.push_back(101);
        }

        int min_index = 0;
        int min_val = 101;
        for (int i = 0; i < n; i++)
        {
            if (new_arr[i] < min_val)
            {
                min_index = i;
                min_val = new_arr[i];
            }
        }

        for (int i = 0; i < n; ++i)
        {
            if (pr[i] < th[i] && (i != min_index && made == true))
            {
                res += th[i];
                themes += "T ";
            }

            if (i == min_index)
                made = false;

            else
            {
                res += pr[i];
                themes += "P ";
            }
        }
    }

    cout << res << endl;
    for (int i = 0; i < themes.size() - 1; ++i)
        cout << themes[i];

    return 0;
}