#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);
}

bool isSq(ll x) {
    return abs(sqrtl(x) - (int)(sqrtl(x))) < 1e-8;
}

ll count_le(ll x) {
    ll cnt = 0;

    for (ll d = 1; d * d <= x; ++d) {
        ll a = d * d;

        auto ra = to_string(a);
        reverse(all(ra));
        if (a % 10 != 0 && isSq(stoll(ra))) {
            cnt++;
            // cout << a << '\n';
        }
    }

    return cnt;
}

inline void solve() noexcept {
    ll a, b;
    cin >> a >> b;
    --a;

    cout << count_le(b) - count_le(a);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio();
    int tt = 1;
    // cin >> tt;
    while (tt-- > 0)
        solve();
    return 0;
}
