
def is_vowel(ch):
    return ch in 'aioue'

def count_vowels(s):
    counter = 0
    for i, ch in enumerate(s):
        if not is_vowel(ch) or i > 0 and is_vowel(s[i - 1]):
            continue
        counter += 1
    return counter

chain = [
    5, 7, 5
]

def check_sequence(seq):
    if sum(seq) != 17:
        return False
    summ = 0
    pos = 0
    for w in seq:
        summ += w
        if pos >= 3 or summ > chain[pos]:
            return False
        elif summ == chain[pos]:
            summ = 0
            pos += 1
    return True


n = int(input())
lst = []
for i in range(n):
    lst.append(count_vowels(input()))

count = 0

for seq_length in range(1, n + 1):
    for i in range(n - seq_length):
        seq = lst[i:i+seq_length]
        count += check_sequence(seq)

print(count)