#include <iostream>
#include <vector>

const long long maxN = 100000, k = 62;
bool used[maxN];
long long n, a[maxN], b[maxN], c[maxN], d, e;
std::vector<long long> err[k + 1], ans;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::fill(used, used + maxN, true);
    std::cin >> n;
    for (long long i = 0; i < n; i++) {
        std::cin >> a[i];
        d ^= a[i];
    }
    for (long long i = 0; i < n; i++) {
        std::cin >> b[i];
        e ^= b[i];
        c[i] = a[i] ^ b[i];
        for (long long j = 0; j <= k; j++)
            if (c[i] & ((long long)1 << j))
                err[j].push_back(i);
    }
    for (long long i = k; i >= 0; i--) {
        if ((d & ((long long)1 << i)) && (e & ((long long)1 << i))) {
            for (long long j : err[i])
                used[j] = false;
        }
        else if (!(d & ((long long)1 << i)) && !(e & ((long long)1 << i))) {
            for (long long j = 0; j < n; j++)
                if (used[j] && (c[j] & ((long long)1 << i))) {
                    d ^= c[j];
                    e ^= c[j];
                    ans.push_back(j);
                    for (long long h : err[i])
                        used[h] = false;
                    break;
                }
        }
    }
    std::cout << d + e << " " << ans.size() << "\n";
    for (long long i : ans)
        std::cout << i + 1 << " ";
    return 0;
}