﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <functional>
#include <climits>
#include <queue>
#include <time.h>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <cassert>

using namespace std;

#define magic_define cin.tie(NULL); ios_base::sync_with_stdio(false); cout << fixed; cout.precision(17);
#define ll long long
#define pii pair<int, int>
#define vi vector<int>



void solve() {
    ll a, b;
    cin >> a >> b;
    ll _a = a, _b = b;
    vector<pair<ll, ll>> ans;
    while (a != 0 && b != 0) {
        if (abs(a) < abs(b)) {
            ans.push_back({ 2, -(b / a) });
            b -= a * (b / a);
        }
        else {
            ans.push_back({ 1, -(a / b) });
            a -= b * (a / b);
        }
    }
    if (ans.size() > 50) {
        ans.clear();
        a = _a, b = _b;
        if (abs(a) < abs(b)) {
            ans.push_back({ 1, -1 });
            a -= b;
        }
        else {
            ans.push_back({ 2, -1 });
            b -= a;
        }
        while (a != 0 && b != 0) {
            if (abs(a) < abs(b)) {
                ans.push_back({ 2, -(b / a) });
                b -= a * (b / a);
            }
            else {
                ans.push_back({ 1, -(a / b) });
                a -= b * (a / b);
            }
        }
    }
    if (ans.size() > 50) {
        exit(-1337);
    }
    cout << ans.size() << "\n";
    for (auto elem : ans)
        cout << elem.first << " " << elem.second << "\n";
}

int32_t main() {
    magic_define;
    solve();
    return 0;
}