﻿#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <iostream>
#include <iomanip>
#include <functional>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <array>
#include <random>
#include <chrono>

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
using namespace std;
using namespace std::chrono;

#define all(x) x.begin(), x.end()
#define int long long

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
}

const int N = 2e5 + 1;
const int INF = 2e9;

void solve() {
	int n, a, b; cin >> n >> a >> b;
	vector<int> v1(n), v2(n);
	for (int i = 0; i < n; i++) {
		cin >> v1[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> v2[i];
	}
	vector<pair<int, int>> d1, d2;
	vector<int> ans(n);
	int sum = 0, cnt1 = 0, cnt2 = 0;
	for (int i = 0; i < n; i++) {
		if (v1[i] > v2[i]) {
			sum += v1[i];
			ans[i] = 1;
			cnt1++;
			d1.push_back({ v1[i] - v2[i], i });
		}
		else {
			sum += v2[i];
			ans[i] = 2;
			cnt2++;
			d2.push_back({ v2[i] - v1[i], i });
		}
	}
	sort(all(d1));
	sort(all(d2));
	if (cnt1 < a) {
		for (int i = 0; i < a - cnt1; i++) {
			ans[d2[i].second] = 1;
			sum -= d2[i].first;
		}
	}
	else {
		for (int i = 0; i < b - cnt2; i++) {
			ans[d1[i].second] = 2;
			sum -= d1[i].first;
		}
	}
	cout << sum << '\n';
	for (int i = 0; i < n; i++) {
		cout << (ans[i] == 1 ? 'T' : 'P') << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	//freopen("game.in", "r", stdin);
	//freopen("game.out", "w", stdout);
	int _t = 1; //cin >> _t;
	while (_t--) {
		solve();
		//gen();
	}
}