// Egor Yukhnevich
#include <bits/stdc++.h>
#include <unordered_set>
#include <unordered_map>
using namespace std;

using u8 = uint8_t;
using u16 = uint16_t;
using u32 = uint32_t;
using u64 = uint64_t;

using s8 = int8_t;
using s16 = int16_t;
using s32 = int32_t;
using s64 = int64_t;

using ld = long double;

/*
* GLOBAL PROJECT SETTINGS
*/

//#define HOME_MODE

//#define DEBUG
//#define MULTITEST
//#define STRESS_TEST // включает HOME_MODE, MULTITEST и тестирует решения

//#define TASK_FILE_NAME "pnumbers" // если есть, включает файловый ввод и вывод

/*
* SIMULATE SETTINGS
*/

#ifdef TASK_FILE_NAME
#define FILE_INPUT TASK_FILE_NAME".in"
#define FILE_OUTPUT TASK_FILE_NAME".out"
#endif

#ifdef STRESS_TEST
#define HOME_MODE // стресс-тест бывает только дома
#define MULTITEST // у нас есть несколько тестов для тестирования
#endif

#ifdef HOME_MODE
#undef FILE_INPUT
#undef FILE_OUTPUT
#define FILE_INPUT "input.txt"
#else
#undef DEBUG
#endif

/*
* SOLVE PROBLEM
*/

//#include<random>
//mt19937_64 rnd(42);



void solve(istream& cin, ostream& cout) {
    s64 a, b;
    cin >> a >> b;
    vector<pair<int, s64>> ans;
    int type = 0;
    if (abs(a) < abs(b)) {
        swap(a, b);
        type = 1;
    }
    bool who = false;
    while (a != 0 && b != 0) {
        int k = -a/b;

        if(who){
            k += k < 0 ? -1 : 1;
        }
        who = !who;

        ans.emplace_back(type + 1, k);
        type = 1 - type;
        a += k*b;
        swap(a, b);
    }
    assert(ans.size() < 51);
    cout << ans.size() << '\n';
    for (auto& x : ans)
        cout << x.first << ' ' << x.second << '\n';

    /*int n;
    cin >> n;
    vector<u64> a(n), b(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    for(int i = 0; i < n; i++){
        cin >> b[i];
    }
    u64 gl_xor = 0;
    for(int i = 0; i < n; i++){
        gl_xor ^= a[i] ^ b[i];
    }

    u64 ans_and = 0;
    {
        u64 x = 0, y = 0;
        for(int i = 0; i < n; i++){
            x ^= a[i];
            y ^= b[i];
        }
        and_and = x & y;
    }
    vector<bool> ans_msk;

    int bad_step = 0;
    while(bad_step < 100){
        vector<bool> msk(n);
        u64 x = 0, y = 0;
        for(int i = 0; i < n; i++){
            msk[i] = rnd() & 1;
            if(msk[i]){
                x ^= b[i];
                y ^= a[i];
            }
            else{
                x ^= a[i];
                y ^= b[i];
            }
        }

        bool up = true;
        while(up){
            up = false;

            for(int i = 0; i < n; i++){

            }
        }
    }

    cout << 2 * ans_and + gl_xor << "\n";*/
}


void main_build() {

}

void correct_solve(istream& cin, ostream& cout) {

}

#ifdef STRESS_TEST

#include <random>
mt19937_64 rnd(42);

// строит тест
string build_test() {
    stringstream out;

    // вывести тест

    return out.str();
}

#endif


/*
* TEMPLATE MAIN
*/

int main() {
    //setlocale(LC_ALL, "Russian");
#ifdef FILE_INPUT
    ifstream cin(FILE_INPUT);
#endif
#ifdef FILE_OUTPUT
    ofstream cout(FILE_OUTPUT);
#endif
    ios::sync_with_stdio(false), cout.tie(nullptr), cin.tie(nullptr);

    main_build();

    s64 t = 1;
#ifdef MULTITEST
    cin >> t;
#endif

    while (t--) {
#ifdef STRESS_TEST
        string test_str_input = build_test(); // создаем тест

        stringstream input1 = stringstream(test_str_input);
        stringstream input2 = stringstream(test_str_input);

        // получаем ответы на тест
        stringstream wrong_out, correct_out;
        solve(input1, wrong_out);
        correct_solve(input2, correct_out);

        // сравниваем их
        if (wrong_out.str() != correct_out.str()) {
            cout << "[failed test]\n" << test_str_input << "\n";

            cout << "[wrong output]\n" << wrong_out.str() << "\n";

            cout << "[correct output]\n" << correct_out.str() << "\n";

            return 0;
        }
#else
        solve(cin, cout);
#endif
    }

#ifdef STRESS_TEST
    cout << "[all tests passed]\n";
#endif

    return 0;
}
