//@author: Kirkon

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <stack>
#include <chrono>
#include <cstdio>
#include <cstdlib>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>


//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, avx2, tune=native")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef float ff;
typedef double lf;
typedef long double llf;

const double eps = 1e-6;
const int int_inf = 2 * 1e9;
const ll ll_inf = 8 * 1e18;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& i : a) {
        out << a;
    }
    return out;
}

template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
    return (ull)rng() % B;
}

ll phin(ll n) { ll number = n; if (n % 2 == 0) { number /= 2; while (n % 2 == 0) n /= 2; } for (ll i = 3; i * i <= n; i += 2) { if (n % i == 0) { while (n % i == 0)n /= i; number = (number / i * (i - 1)); } } if (n > 1)number = (number / n * (n - 1)); return number; } //O(sqrt(N))

vector<pll> q;
set<ll> p;

void get_solve(ll a, ll b){
    if(abs(a) % abs(b) == 0){
        ll k = abs(a) / abs(b);
        k *= abs(a) / a;
        k *= abs(b) / b;
        k *= -1;
        q.push_back({1, k});
        return;
    }
    if(abs(b) % abs(a) == 0){
        ll k = abs(b) / abs(a);
        k *= abs(a) / a;
        k *= abs(b) / b;
        k *= -1;
        q.push_back({2, k});
        return;
    }
    if(abs(a) > abs(b)){
        ll k = abs(a) / abs(b);
        if(p.count(abs(a) + abs(b)) == 1){
            if(k == 1) k += 1;    
        }
        
        k *= abs(a) / a;
        k *= abs(b) / b;
        k *= -1;
        q.push_back({1, k});
        a += k * b;
        return get_solve(a, b);
    }else{
        ll k = abs(b) / abs(a);
        if(p.count(abs(b) + abs(a)) == 1){
            if(k == 1) k += 1;    
        }
        k *= abs(a) / a;
        k *= abs(b) / b;
        k *= -1;
        q.push_back({2, k});
        b += k * a;
        return get_solve(a, b);
    }
}

int solve(){
    ll a, b;
    cin >> a >> b;
    if(a == 0 || b ==0){
        cout << "0";
        return 0;
    }
    get_solve(a, b);
    cout << q.size() << '\n';
    for(int i = 0; i < q.size(); ++i){
        cout << q[i].fi << " " << q[i].se << '\n';
    }
    return 0;
}



signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    vector<ll> fibb(100, 0);
    fibb[0] = fibb[1] = 1;
    for(int i = 2; i < 100; ++i){
        fibb[i] = fibb[i - 1] + fibb[i - 2];
        p.insert(fibb[i]);  
    } 
    solve();
    return 0;
}
