//@author: Kirkon

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <stack>
#include <chrono>
#include <cstdio>
#include <cstdlib>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>


//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, avx2, tune=native")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef float ff;
typedef double lf;
typedef long double llf;

const double eps = 1e-6;
const int int_inf = 2 * 1e9;
const ll ll_inf = 8 * 1e18;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& i : a) {
        out << a;
    }
    return out;
}

template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
    return (ull)rng() % B;
}

ll phin(ll n) { ll number = n; if (n % 2 == 0) { number /= 2; while (n % 2 == 0) n /= 2; } for (ll i = 3; i * i <= n; i += 2) { if (n % i == 0) { while (n % i == 0)n /= i; number = (number / i * (i - 1)); } } if (n > 1)number = (number / n * (n - 1)); return number; } //O(sqrt(N))



void solve(){
    ll a, b;
    cin >> a >> b;
    if(a == 0 || b ==0){
        cout << "0";
        return;
    }
    vector<pll> q;
    if(a > 0 && b < 0){
        ll pos_b = b * (-1);
        if(pos_b % a == 0){
            cout << "1\n";
            cout << "2 " << pos_b/a;
            return;
        }
        ll k = pos_b / a + 1;
        q.push_back({2, k});
        b += k * a;
        //if(abs(b) > 1e18) assert(false);
    }
    if(a < 0 && b > 0){
        ll pos_a = a * (-1);
        if(pos_a % b == 0){
            cout << "2\n";
            cout << "1 " << pos_a/b;
            return;
        }
        ll k = pos_a / b + 1;
        q.push_back({1, k});
        a += k * b;
        //if(abs(a) > 1e18) assert(false);
    }
    
    if(abs(a) > 1e18) assert(false);
    if(abs(b) > 1e18) assert(false);
    
    if(a > 0 && b > 0){
        while(true){
            if(a > b){
                ll k = a / b;
                q.push_back({1, -k});
                a = a - k*b;
                
                if(a == 0) break;
            }else{
                ll k = b / a;
                q.push_back({2, -k});
                b = b - k*a;
                
                if(b == 0) break;
            }
        }
    }
    if(a < 0 && b < 0){
        a *= -1;
        b *= -1;
        while(true){
            if(a > b){
                ll k = a / b;
                q.push_back({1, -k});
                a = a - k*b;
                //if(abs(a) > 1e18) assert(false);
                if(a == 0) break;
            }else{
                ll k = b / a;
                q.push_back({2, -k});
                b = b - k*a;
                //if(abs(b) > 1e18) assert(false);
                if(b == 0) break;
            }
        }
    }
    //if(q.size() > 50) assert(false);
    cout << q.size() << '\n';
    for(int i = 0; i < q.size(); ++i){
        cout << q[i].fi << " " << q[i].se << '\n';
    }
    return;
}



signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    //ll a = myRand(1e18), b = -myRand(1e18);
    //ll i = 1;
    //while(solve(a, b) <= 50){
    //    ++i;
    //    if(i % 1000 == 0){
    //        cout << "TEST " << i << "Passed";
    //    }
    //}
    solve();
    return 0;
}
