#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second
#define sz(x) (int)(x).size()
#define endl "\n"
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;


int sign(ll a) {
    if(a < 0) return -1;
    if(a > 0) return 1;
    return 0;
}

long long a, b;
vector <pair <ll, ll> > ans;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);

//    vector<ll> fib({0, 1});
//    while(fib.back() + fib[sz(fib) - 2] <= 1e18) {
//        fib.pb(fib.back() + fib[sz(fib) - 2]);
//    }
//
//    a = fib.back();
//    b = fib[sz(fib) - 2];
    cin >> a >> b;
    while (true)
    {
        if (a == 0 or b == 0) break;
        long long A = abs(a);
        long long B = abs(b);
        long long h;
        long long k;
//        cout << a << " " << b << endl;
        if (A > B)
        {
            h = 1;
            k = (A + B - 1) / B;
        } else {
            h = 2;
            k = (B + A - 1) / A;
        }

        if (sign(b) == sign(a))
        {
            if (h == 1)
            {
                a += -sign(a) * B * k;
                ans.push_back({h, sign(a)*k});
            }
            else
            {
                b += -sign(b) * A * k;
                ans.push_back({h, sign(b)*k});
            }
        }
        else
        {
            if (h == 1)
            {
                a += b * k;
                ans.push_back({h, k});
            }
            else
            {
                b += a * k;
                ans.push_back({h, k});
            }
        }
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); i++)
        cout << ans[i].fi << " " << ans[i].se << endl;
    return 0;
}
