#include "bits/stdc++.h"
#define fori for (int i = 0; i < n; ++i)
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
#ifdef qwe
bool debug = true;
#else
bool debug = false;
#endif

inline void solve() {
	ll n;
	cin >> n;

	vector <ll> a(n);
	set <pair <int, int>> blocked;

	auto query = [&blocked] (int l, int r) {
		cout << "? " << l + 1 << ' ' << r + 1 << endl;

		ll s, lb, lr;
		cin >> s >> lb >> lr;

		blocked.emplace(lb, lr);

		return s;
	};

	auto can_query = [&blocked] (int l, int r) {
		return blocked.find({l + 1, r + 1} ) == blocked.end();
	};

	for (int i = 0; i < n; i++) {
		ll gay = 0;
		for (int j = i; j >= 0; j--) {
			gay += a[j];
			if (can_query(j, i)) {
				ll s = query(j, i);
				a[i] = s - gay;
				break;
			}
		}
	}	


	cout << "!\n";

	for (int x: a) cout << x << ' ';
	cout << endl;
}

int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	solve();
}
