#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;

const int N = 3e5;

int n, a, b, x[N], y[N], cnt_t, cnt_p, ideal_sum;
char ans[N];
vector<int> ideal_t, ideal_p;

int main() {
  	ios_base::sync_with_stdio(0);
  	cin.tie(0); cout.tie(0);
  	//freopen(".in", "r", stdin);
  	//freopen(".out", "w", stdout);
  	cin >> n >> a >> b;
  	for (int i = 1; i <= n; i++) {
  		cin >> x[i]; 
  	}
  	for (int i = 1; i <= n; i++) {
  		cin >> y[i];
  		if (x[i] >= y[i]) {
  			cnt_t++;
  			ideal_t.pb(i);
  			ideal_sum += x[i];
  			ans[i] = 'T';
  		}
  		else {
  			cnt_p++;
  			ideal_p.pb(i);
  			ideal_sum += y[i];
  			ans[i] = 'P';
  		}
  	}
  	if (cnt_t < a) {
  		int k = a - cnt_t;
  		vector<pair<int, int>> dif;
  		for (auto i : ideal_p) {
  			dif.pb({y[i] - x[i], i});
  		}
  		sort(dif.begin(), dif.end());
  		int cut = 0;
  		for (auto [d, id] : dif) {
  			if (k == 0) break;
  			cut += d;
  			ans[id] = 'T';
  			--k;
  		}
  		cout << ideal_sum - cut << "\n";
  		for (int i = 1; i <= n; i++) cout << ans[i] << ' ';
  	}
  	else if (cnt_p < b) {
  		int k = b - cnt_p;
  		vector<pair<int, int>> dif;
  		for (auto i : ideal_t) {
  			dif.pb({x[i] - y[i], i});
  		}
  		sort(dif.begin(), dif.end());
  		int cut = 0;
  		for (auto [d, id] : dif) {
  			if (k == 0) break;
  			cut += d;
  			ans[id] = 'P';
  			--k;
  	 	}
  		cout << ideal_sum - cut << "\n";
  		for (int i = 1; i <= n; i++) cout << ans[i] << ' ';
  	}
  	else {
  		cout << ideal_sum << "\n";
  		for (int i = 1; i <= n; i++) cout << ans[i] << ' ';
  	}
  	return 0;
}
