#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <chrono>
#include <string>
#include <string.h>
#include <set>

using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) (x).begin(),(x).end()
#define pb push_back
#define ll long long

ll gcd(ll a, ll b){
    if(!b) return a;
    return gcd(b, a % b);
}

ll lcm(ll a, ll b){
    return (a / gcd(a, b)) * b;
}

ll binpow(ll a, ll b, ll m){
    a %= m;
    if(b == 1) return a;
    ll k = binpow(a, b / 2, m) % m;
    k = k * k; k %= m;
    if(b % 2) k = (k * a) % m;
    return k % m;
}

int rev(int a){
    if(a % 10 == 0) return -1;
    vector <int> v;
    while(a > 0){
        v.pb(a % 10);
        a /= 10;
    }
    int res = 0;
    for(auto &x: v){
        res *= 10;
        res += x;
    }
    return res;
}

int const N = 1e11 + 9;

void t_main(){
    int a, b; cin >> a >> b;
    set <int> s;
    
    
    for(int i = 1; i * i <= N; i ++){
        s.insert(i * i);
    }
    
    int ans = 0;
    for(int i = 1; i * i <= b; i ++){
        int c = rev(i * i);
        if(i * i >= a and i * i <= b and c != -1 and s.find(c) != s.end())
            ans ++;
    }
    cout << ans << "\n";
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    // << rev(12223);
    int tt = 1;
    //cin >> tt;
    
    while(tt --) t_main();
    return 0;
}
