﻿#include <ctime>
#include <random>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


int Sign(int x) {
	if (x > 0)
		return 1;
	if (x < 0)
		return -1;
	return 0;
}


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(30);

	ll a, b;
	cin >> a >> b;

	int st = 0;
	if (abs(a) < abs(b)) {
		swap(a, b);
		st++;
	}

	vector < int > ty, rk;
	for (int i = st; b != 0; i++) {
		ty.push_back(i % 2 + 1);

		int k = -Sign(a) * Sign(b) * (abs(a) / abs(b));
		rk.push_back(k);
		a = Sign(a) * (abs(a) % abs(b));
		if (abs(a) > abs(a - Sign(a) * abs(b)))
			a -= Sign(a) * abs(b);
		swap(a, b);
	}

	assert(ty.size() <= 50);
	cout << ty.size() << "\n";
	for (int i = 0; i < ty.size(); i++)
		cout << ty[i] << " " << rk[i] << "\n";

	return 0;
}