#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;

vector<int> dp, sdp;

bool cmp(int a, int b) {
    if (dp[a] >= dp[b]) return 1;
    return 0;
}

int main(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(0);

    int n, a, b;
    cin >> n >> a >> b;
    dp.resize(n);
    sdp.resize(n);
    vector<int> p(n), t(n);

    for (int i = 0; i < n; i++) cin >> t[i];
    for (int i = 0; i < n; i++) cin >> p[i];



    for (int i = 0; i < n; i++) {
        sdp[i] = i;
        dp[i] = p[i] - t[i];
    }

    sort(sdp.begin(), sdp.end(), cmp);

    vector<char> ans(n);

    for (int i = 0; i < b; i++) {
        ans[sdp[i]] = 'P';
    }
    for (int i = n; i >= n-a; i--) {
        ans[sdp[i-1]] = 'T';
    }
    for (int i = b; i < n-a; i++) {
        if (dp[sdp[i]] < 0) ans[i] = 'T';
        else ans[i] = 'P';
    }

    int cans = 0;
    for (int i = 0; i < n; i++) {
        cans += (ans[i] == 'P' ? p[i] : t[i]);
    }

    cout << cans << '\n';
    for (int i = 0; i < n; i++) {
        cout << ans[i] << ' ';
    }
    cout << '\n';

    return 0;
}
