﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ctype.h>
#include <deque>
#include <cstring>
#include <set>
#include <bitset>
#include <map>
#include <chrono>
#include <random>
#include <unordered_map>
#include <stdio.h>

using namespace std;

//╱╱╭━╮╭━┳━━━┳━╮╱╱╱╱╱╱╭━┳━━━┳━╮╭━╮
//╱╭╯╭╋╯╭┫╭━╮┣╮╰╮╱╱╱╱╭╯╭┫╭━╮┣╮╰╋╮╰╮
//╭╯╭╋╯╭╯┃┃┃┃┃╰╮╰┳╮╭┳╯╭╯┃┃┃┃┃╰╮╰╋╮╰╮
//┃┃┃┃┃┃╱┃┃┃┃┃╱┃┃┃╰╯┃┃┃╱┃┃┃┃┃╱┃┃┃┃┃┃
//┃┃┃┃┃┃╱┃╰━╯┃╱┃┃┣╮╭┫┃┃╱┃╰━╯┃╱┃┃┃┃┃┃
//╰╮╰╋╮╰╮╰━━━╯╭╯╭╯╰╯╰╮╰╮╰━━━╯╭╯╭╋╯╭╯
//╱╰╮╰╋╮╰╮╱╱╱╭╯╭╯╱╱╱╱╰╮╰╮╱╱╱╭╯╭╋╯╭╯
//╱╱╰━╯╰━╯╱╱╱╰━╯╱╱╱╱╱╱╰━╯╱╱╱╰━╯╰━╯

void solve() {
    int n;
    cin >> n;
    vector<long long> sol(n);
    set<pair<long long, long long>> arr;
    cout << "? 1 1 \n";
    for (int i = 1; i < n; ++i) {
        long long x, l, r;
        cin >> x >> l >> r;
        sol[i - 1] += x;
        arr.insert({ l, r });

        for (int li = 1; li <= i + 1; ++li) {
            if (arr.find({ li, i + 1 }) == arr.end()) {
                long long sum = 0;
                for (int j = li - 1; j <= i; ++j) {
                    sum += sol[j];
                }
                sol[i] = -sum;
                cout << "? " << li << " " << i + 1 << "\n";
                break;
            }
        }
    }
    long long x, l, r;
    cin >> x >> l >> r;
    sol[n - 1] += x;
    cout << "!\n";
    for (long long it : sol) {
        cout << it << " ";
    }
    cout << "\n";
}


int main() {
    /*ios_base::sync_with_stdio(false);
    srand((unsigned int)time(nullptr));
    cout.setf(ios::fixed);
    cout.precision(9);
    cout.tie(nullptr);
    cin.tie(nullptr);*/

    int T = 1;
    //cin >> T;
    while (T--) { solve(); }

    return (0 - 0); //;(
}