﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ctype.h>
#include <deque>
#include <cstring>
#include <set>
#include <bitset>
#include <map>
#include <chrono>
#include <random>
#include <unordered_map>
#include <stdio.h>

using namespace std;

//╱╱╭━╮╭━┳━━━┳━╮╱╱╱╱╱╱╭━┳━━━┳━╮╭━╮
//╱╭╯╭╋╯╭┫╭━╮┣╮╰╮╱╱╱╱╭╯╭┫╭━╮┣╮╰╋╮╰╮
//╭╯╭╋╯╭╯┃┃┃┃┃╰╮╰┳╮╭┳╯╭╯┃┃┃┃┃╰╮╰╋╮╰╮
//┃┃┃┃┃┃╱┃┃┃┃┃╱┃┃┃╰╯┃┃┃╱┃┃┃┃┃╱┃┃┃┃┃┃
//┃┃┃┃┃┃╱┃╰━╯┃╱┃┃┣╮╭┫┃┃╱┃╰━╯┃╱┃┃┃┃┃┃
//╰╮╰╋╮╰╮╰━━━╯╭╯╭╯╰╯╰╮╰╮╰━━━╯╭╯╭╋╯╭╯
//╱╰╮╰╋╮╰╮╱╱╱╭╯╭╯╱╱╱╱╰╮╰╮╱╱╱╭╯╭╋╯╭╯
//╱╱╰━╯╰━╯╱╱╱╰━╯╱╱╱╱╱╱╰━╯╱╱╱╰━╯╰━╯

vector<long long> qrt;
set<long long> fqrt;
//
long long revers(long long n) {
    string str;
    long long x = 1;
    if (n % 10 == 0) {
        return -1;
    }
    while (n > 0) {
        x *= 10;
        str += ('0' + n % 10);
        n /= 10;
    }
    x /= 10;
    int i = 0;
    while (x > 0) {
        n += (str[i] - '0') * x;
        ++i;
        x /= 10;
    }
    return n;
}

long long f(long long x) {
    long long sol = 0;
    int i = 0;
    while (qrt[i] <= x) {
        if (fqrt.find(revers(qrt[i])) != fqrt.end()) {
            ++sol;
        }
        ++i;
    }
    return sol;
}

void solve() {
    long long a, b;
    cin >> a;
    cin >> b;
    for (long long i = 1; i < 1e6; ++i) {
        qrt.push_back(i * i);
        fqrt.insert(i * i);
    }
    cout << f(b) - f(a - 1);
}


int main() {
    /*ios_base::sync_with_stdio(false);
    srand((unsigned int)time(nullptr));
    cout.setf(ios::fixed);
    cout.precision(9);
    cout.tie(nullptr);
    cin.tie(nullptr);*/

    int T = 1;
    //cin >> T;
    while (T--) { solve(); }

    return (0 - 0); //;(
}