#define _USE_MATH_DEFINES
#include <fstream>
#include <iostream>
#include <math.h>
#include <vector>
#include <cmath>
#include <iomanip>
#include <string>
#include <set>
#include <algorithm>
#include <deque>
#include <map>
#include <sstream>
#include <unordered_set>
#include <unordered_map>
typedef unsigned long long ul;
typedef long long ll;
typedef long double ld;
typedef double db;
using namespace std;
/*ifstream in("input.txt");
ofstream out("output.txt");*/
void dfs(vector<vector<int>>& g, vector<bool>& used, vector<int>& a, int v, int x, int& ans) {
    used[v] = true;
    if (v == g.size() - 1) {
        ans = max(ans, x);
        return;
    }
    for (int i = 0; i < g[v].size(); i++) {
        if (!used[g[v][i]]) {
            dfs(g, used, a, g[v][i], (x > a[g[v][i]] ? x : x / 2), ans);
            used[g[v][i]] = true;
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    vector<bool> used(n);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        g[x - 1].push_back(y - 1);
        g[y - 1].push_back(x - 1);
    }
    int x, ans = 0;
    vector<int> a(n);
    cin >> x;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    dfs(g, used, a, 0, (x > a[0] ? x : x / 2), ans);
    cout << ans;
}