#include <iostream>
#include <vector>
#include <queue>
using namespace std;

typedef long long ll;
int n, m;
ll x;
vector<int> g[200005];
int u[200005], d[200005], a[200005];

int main()
{
    ios_base::sync_with_stdio(0);

    cin >> n >> m;

    for(int i = 0; i < m; i++)
    {
        int x, y;
        cin >> x >> y;

        x--, y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }


    cin >> x;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    queue<int> q;
    u[0] = 1;

    d[0] = x / 2;
    if (x > a[0])
        d[0] = x;

    q.push(0);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();

        for (int j = 0; j < g[v].size(); j++)
        {
            int i = g[v][j];
            ll t = d[v];
            if (a[i] >= d[v])
                t = d[v] / 2;
            if(d[i] < t)
            {
                u[i] = true;
                d[i] = t;
                q.push(i);
            }
        }
    }

    cout << d[n - 1];

}
