import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;

public class E {

    public static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    public static StringTokenizer tokenizer = null;

    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void flush() throws IOException {
        writer.flush();
    }

    public static void println() throws IOException {
        writer.newLine();
    }

    public static void print(String s) throws IOException {
        writer.write(s);
    }

    public static void println(String s) throws IOException {
        print(s);
        println();
    }


    public static void main(String[] args) throws IOException {
        taskE();
    }

    public static void taskE() throws IOException {
        int n = nextInt();
        int[] words = new int[n];
        for (int i = 0; i < n; i++) {
            String s = next();
            boolean last = false;
            for (int j = 0; j < s.length(); j++) {
                char c = s.charAt(j);
                if (c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u') {
                    if (!last) {
                        words[i]++;
                        last = true;
                    }
                } else last = false;
            }
        }
        List<Integer> list = new ArrayList<>();
        for (int i = 0; i < n; i++) for (int j = 0; j < words[i]; j++) list.add(i);
        int ans = 0;
        int ind = 0;
        while (ind + 16 < list.size()) {
            int a = ind == 0 ? -1 : list.get(ind - 1);
            int b = list.get(ind);
            int c = list.get(ind + 4);
            int d = list.get(ind + 5);
            int e = list.get(ind + 11);
            int f = list.get(ind + 12);
            int g = list.get(ind + 16);
            int h = ind + 17 == list.size() ? -1 : list.get(ind + 17);
            if (a != b && c != d && e != f && g != h) {
                ans++;
            }
            ind++;
        }
        println(ans + "");
        flush();
    }

}
