#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

const ll maxn = 1e5;
const ld eps = 1e-7;

int main() {
    std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ld x, t;
    cin >> x >> t;
    ld res = -INF;
    if (res + eps < 1.0 * 200 / 3 * t)
        res = 1.0 * 200 / 3 * t;
        if (res + eps < 1.0 * 5 / 6 * x * t)
            res = 1.0 * 5 / 6 * x * t;
        if (fabs(x - 100) > eps)
            if (t / 6 <= t * (8 * x - 700) / 12 / (x - 100) + eps && t * (8 * x - 700) / 12 / (x - 100) + eps <= t / 3) {
                ld a = t * (8 * x - 700) / 12 / (x - 100);
                if (res + eps < (6 * a * (100 - x) / t + 2 * x - 100) * (t - a));
                    res = (6 * a * (100 - x) / t + 2 * x - 100) * (t - a);
            }
    cout.setf(ios::fixed);
    cout.precision(8);
    cout << res;
}
