#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
    for (T i : vec) {
        os << i << ' ';
    }
    return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
    for (vector<T> i : vec) {
        os << i << '\n';
    }
    return os;
}

bool is_vowel(char a) {
	if (a == 'a' || a == 'e' || a == 'o' || a == 'u' || a == 'i') {
		return true;
	}
	return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        string b;
        cin >> b;
        int cur_ans = 0;
        int cur = 0;
		
		for (int j = 0; j < b.size(); j++) {
		    if (cur == 0) {
		    	if (is_vowel(b[j])) {
		    		cur = 1;
		    	}
		    } else {
		    	if (!is_vowel(b[j])) {
		    		cur = 0;
		    		cur_ans += 1;
		    	}
		    }
		}
		if (cur == 1) {
			cur_ans += 1;
		}
		a[i] = cur_ans;
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int j = i;
        int cur = 0;
        bool flag1 = true;
        bool flag2 = true;
        while (j < n) {
        	cur += a[j];
        	if (flag1) {
        		if (cur == 5) {
			        if (flag2) {
				        flag1 = false;
				        cur = 0;
			        } else {
			        	ans += 1;
				        break;
			        }
        		} else if (cur > 5){
			        break;
        		}
        	} else {
        		if (cur == 7) {
        			flag2 = false;
        			flag1 = true;
        			cur = 0;
        		} else if (cur > 7) {
			        break;
        		}
        	}
        	j += 1;
        }
    }
    cout << ans << '\n';
    
    
}

int32_t main() {
    start;

    solve();

    finish;
}