#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
	for (auto &i : vec) {
		is >> i;
	}
	return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
	for (T i : vec) {
		os << i << ' ';
	}
	return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
	for (vector<T> i : vec) {
		os << i << '\n';
	}
	return os;
}

vector<int> x, y;

bool cmp1(int i, int j) {
	return y[i] - x[i] < y[j] - x[j];
}

bool cmp2(int i, int j) {
	return x[i] - y[i] < x[j] - y[j];
}

void solve() {
	int n, a, b;
	cin >> n >> a >> b;
	int cura = 0, curb = 0;
	x.assign(n, 0);
	y.assign(n, 0);
	cin >> x >> y;
	int ans = 0;
	vector<int> anses(n);
	for (int i = 0; i < n; i++) {
		if (x[i] > y[i]) {
			ans += x[i];
			anses[i] = 1;
			cura += 1;
		} else {
			ans += y[i];
			curb += 1;
		}
	}
	vector<int> is(n);
	for (int i = 0; i < n; i++) {
		is[i] = i;
	}
	if (cura < a) {
		sort(is.begin(), is.end(), cmp1);
		
			for (int i = 0; i < n; i++) {
			    if (anses[is[i]] == 0) {
			    	anses[is[i]] = 1;
			    	cura += 1;
			    	ans -= y[is[i]];
			    	ans += x[is[i]];
			    }
			    if (cura == a) {
				    break;
			    }
			}
		
		
	} else if (curb < b){
		sort(is.begin(), is.end(), cmp2);
		
			for (int i = 0; i < n; i++) {
				if (anses[is[i]] == 1) {
					anses[is[i]] = 0;
					curb += 1;
					ans += y[is[i]];
					ans -= x[is[i]];
				}
				if (curb == b) {
					break;
				}
			}
		
	}
	
	cout << ans << '\n';
	for (int i = 0; i < n; i++) {
		if (anses[i] == 1) {
			cout << "T ";
		} else {
			cout << "P ";
		}
	}
}

int32_t main() {
	start;
	
	solve();
	
	finish;
}