#include <unordered_set>
#include <unordered_map>
//#include <ext/rope>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <chrono>
#include <string>
#include <vector>
#include <bitset>
#include <cstdio>
#include <random>
#include <stack>
#include <cmath>
#include <queue>
#include <ctime>
#include <map>
#include <set>

//using namespace __gnu_cxx;
using namespace std;

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

typedef long long ll;   
typedef long double ld;
typedef pair <int, int> ii;
typedef pair <ll, ll> dl;
typedef vector <vector <int> > graph;

#define pb push_back
#define eb emplace_back 
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()
 
const ll INF = 1e18;
const ld EPS = 1e-9;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2e5 + 1000;

#define fast() ios_base::sync_with_stdio(0); cin.tie(0)

priority_queue<pair<ll, pair<int, int>>> u;
vector<vector<ll>> dp;

vector<vector<ll>> a;

int main() {
    fast();
    
    #ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int n, m;
    cin >> n >> m;
    a.resize(m);
    dp.resize(m);

    pair<int, int> s, t;

    for (int i = 0; i < m; i++) {
        dp[i].resize(n, INF);
        int x, y;
        cin >> x >> y;
        x--, y--;

        if (i == 0)
            s = {0, x};

        for (int j = 0; j < n; j++) {
            if (j < x)
                a[i].pb(x - j);
            else if (j > y)
                a[i].pb(j - y);
            else {
                a[i].pb(0);
            }
        }
    }

    dp[s.first][s.second] = 0;

    u.push({a[s.first][s.second], s});
    while (!u.empty()) {
        pair<int, int> v = u.top().second;
        u.pop();
        if (v.second < n - 1 && dp[v.first][v.second + 1] > dp[v.first][v.second] + a[v.first][v.second + 1]) {
            dp[v.first][v.second + 1] = dp[v.first][v.second] + a[v.first][v.second + 1];
            u.push({dp[v.first][v.second + 1], {v.first, v.second + 1}});
        }
        if (v.first < m - 1 && dp[v.first + 1][v.second] > dp[v.first][v.second] + a[v.first + 1][v.second]) {
            dp[v.first + 1][v.second] = dp[v.first][v.second] + a[v.first + 1][v.second];
            u.push({dp[v.first + 1][v.second], {v.first + 1, v.second}});
        }
        if (v.second > 1 && dp[v.first][v.second - 1] > dp[v.first][v.second] + a[v.first][v.second - 1]) {
            dp[v.first][v.second - 1] = dp[v.first][v.second] + a[v.first][v.second - 1];
            u.push({dp[v.first][v.second - 1], {v.first, v.second - 1}});
        }
        if (v.first > 1 && dp[v.first - 1][v.second] > dp[v.first][v.second] + a[v.first - 1][v.second]) {
            dp[v.first - 1][v.second] = dp[v.first][v.second] + a[v.first - 1][v.second];
            u.push({dp[v.first - 1][v.second], {v.first - 1, v.second}});
        }
    }

    ll ans = dp[m - 1][0];

    for (int i = 1; i < n; i++)
        ans = min(ans, dp[m - 1][i]);

    cout << ans << '\n';

    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif 
    return 0;
}