#include <unordered_set>
#include <unordered_map>
//#include <ext/rope>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <chrono>
#include <string>
#include <vector>
#include <bitset>
#include <cstdio>
#include <random>
#include <stack>
#include <cmath>
#include <queue>
#include <ctime>
#include <map>
#include <set>

//using namespace __gnu_cxx;
using namespace std;

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

typedef long long ll;   
typedef long double ld;
typedef pair <int, int> ii;
typedef pair <ll, ll> dl;
typedef vector <vector <int> > graph;

#define pb push_back
#define eb emplace_back 
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()
 
const int INF = 1e9;
const ld EPS = 1e-8;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2e5 + 1000;

#define fast() ios_base::sync_with_stdio(0); cin.tie(0)

vector<vector<int>> g;
int a[MAXN];
int dp[MAXN];
priority_queue<pair<int, int>> u;

int main() {
    fast();
    
    #ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, m;
    cin >> n >> m;
    g.resize(n + 1);

    fill(dp, dp + n + 1, -1);

    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
    }
    int x;
    cin >> x;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    if (a[1] >= x)
        dp[1] = x / 2;
    else
        dp[1] = x;

    u.push({dp[1], 1});

    while (!u.empty()){
        int v = u.top().second;
        u.pop();
        //cout << u.top().first << ' ' << u.top().second << '\n';
        for (int j = 0; j < g[v].size(); j++) {
            if (a[g[v][j]] >= dp[v] && dp[g[v][j]] < dp[v] / 2){
                dp[g[v][j]] = dp[v] / 2;
                u.push({dp[g[v][j]], g[v][j]});
                //cout << "pushed " << dp[g[v][j]] << ' ' << g[v][j] << '\n';
            }
            else if (a[g[v][j]] < dp[v] && dp[g[v][j]] < dp[v]){
                dp[g[v][j]] = dp[v];
                u.push({dp[g[v][j]], g[v][j]});
               // cout << "pushed " << dp[g[v][j]] << ' ' << g[v][j] << '\n';
            }
        }
        
    }
    cout << dp[n] << '\n';
    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif 
    return 0;
}