#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ctime>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;

#define fast() {\
    ios_base::sync_with_stdio(false);\
    cin.tie(0);\
    cout << fixed << setprecision(0);\
}
#define op(){\
    freopen("input.txt", "r", stdin);\
    freopen("output.txt", "w", stdout);\
}

#define f first
#define s second
#define pb push_back
#define sqr(a) ((a) * (a))

using ll = long long;
using ld = long double;
using pi = array<int, 2>;
using pl = array<ll, 2>;
using pd = array<double, 2>;
using pld = array<ld, 2>;
using graph = vector<vector<ll> >;
using vll = vector<ll>;
using vii = vector<int>;
using vdd = vector<double>;

const ll INF = 1e+9 + 7;
const ll MEGAINF = 1e18 + 7;
const ll P = 31;
const ld EPS = 1e-6;
const ld PI = 3.14159265358979323;
const int MAXN = 1e6 + 10;
const int LOG = 30;


ll n, m;
vector<vll> dp;
vector<array<ll, 2>> ls;
vector<ll> node;


void build(ll v, ll l, ll r, ll p){
    if (l + 1 == r) {
        node[v] = dp[l][p - 1];
        return;
    }
    ll m = (l + r) / 2;
    build(v * 2, l, m, p);
    build(v * 2 + 1, m, r, p);
    node[v] = min(node[v * 2], node[v * 2 + 1]);
    return;
}


ll findRes(ll v, ll l, ll r, ll L, ll R) {
    if (l >= L && r <= R)
        return node[v];
    if (r <= L || l >= R)
        return INF;
    ll m = (l + r) / 2;
    return min(findRes(v * 2, l, m, L, R), findRes(v * 2 + 1, m, r, L, R));
}


int main()
{
    fast();

    #ifdef _LOCAL
        clock_t Tsart = clock();
        op();
    #endif

    ll a, b;
    cin >> n >> m;
    dp.resize(n, vll(m));
    ls.resize(m);
    node.resize(4 * n + 4);
    for (int i = 0; i < m; i++) {
        cin >> ls[i][0] >> ls[i][1];
        --ls[i][0], --ls[i][1];
    }

    for (int j = 0; j < m; j++) {
            if (j != 0)
                build(1, 0, n, j);
        for (int i = 0; i < n - (ls[j][1] - ls[j][0]); i++) {
            if (j){
                dp[i][j] = findRes(1, 0, n, max(0LL, i - (ls[j - 1][1] - ls[j - 1][0])), min(n, i + (ls[j][1] - ls[j][0]))) + abs(ls[j][0] - i);
            } else {
                dp[i][j] = abs(ls[j][0] - i);
            }
        }
    }
    ll ans = dp[0][m - 1];
    for (int i = 0; i < n - (ls[m - 1][1] - ls[m - 1][0]); i++) {
        ans = min(ans, dp[i][m - 1]);
    }
    cout << ans << '\n';

    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif

    return 0;
}

