#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ctime>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;

#define fast() {\
    ios_base::sync_with_stdio(false);\
    cin.tie(0);\
    cout << fixed << setprecision(0);\
}
#define op(){\
    freopen("input.txt", "r", stdin);\
    freopen("output.txt", "w", stdout);\
}

#define f first
#define s second
#define pb push_back
#define sqr(a) ((a) * (a))

using ll = long long;
using ld = long double;
using pi = array<int, 2>;
using pl = array<ll, 2>;
using pd = array<double, 2>;
using pld = array<ld, 2>;
using graph = vector<vector<ll> >;
using vll = vector<ll>;
using vii = vector<int>;
using vdd = vector<double>;

const ll INF = 1e+9 + 7;
const ll MEGAINF = 1e18 + 7;
const ll P = 31;
const ld EPS = 1e-6;
const ld PI = 3.14159265358979323;
const int MAXN = 1e6 + 10;
const int LOG = 30;

int cnt = 0;
vector <pair <ll, ll> > ans;

void gcd (ll a, ll b) {
    cnt++;
    if (a == 0)
        return;
    if (b == 0)
        return;
    if (abs(a) > abs(b)) {
        ll k = abs(a / b);
        if (abs(a % b - b) < abs(a % b) || abs(a % b + b) < abs(a % b))
            k++;
        if (a / b < 0){
            ans.pb({1, k});
            gcd(a + k * b, b);
        } else {
            ans.pb({1, -k});
            gcd(a - k * b, b);
        }
    }
    else {
        ll k = abs(b / a);
        if (abs(b % a - a) < abs(b % a) || abs(b % a + a) < abs(b % a))
            k++;
        if (b / a < 0){
            ans.pb({2, k});
            gcd(a, b + a * k);
        } else{
            ans.pb({2, -k});
            gcd(a, b - a * k);
        }
    }
}

int main()
{
    fast();

    #ifdef _LOCAL
        clock_t Tsart = clock();
        op();
    #endif

    ll n, s, v;
    map<ll, ll> mp;
    vector<pl> a;
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> s >> v;
        a.pb({s, v});
    }
    ll mx = 0;
    ll t;
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++){
            for (int k = 0; k < n; k++){
                if (k == i || j == k)
                    continue;
                ll d = abs(a[i][1] - a[j][1]);
                if (k < i){
                    t = (a[i][0] - a[k][0]) / max(1LL, (a[k][1] - a[i][1] - d * (i - k)));
                } else {
                    t = (a[i][0] - a[k][0]) / max(1LL, (a[k][1] - a[i][1] + d * (k - i)));
                }
                mp[t]++;
            }
            for (auto it : mp)
                mx = max(mx, it.second);
            mp.clear();
        }
    cout << mx + 2 << '\n';

    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif

    return 0;
}

/* 1100087778366101931 679891637638612258 */
