#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18 + 7;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

void solve() {
    int n, a, b;
    cin >> n >> a >> b;
    vector<int> x(n), y(n);
    for (auto &w : x) cin >> w;
    for (auto &w : y) cin >> w;
    vector<int> p(n);
    for (int i = 0; i < n; i++) p[i] = i;
    sort(p.begin(), p.end(), [&] (const int& i, const int& j) {
        return (x[i] - y[i]) > (x[j] - y[j]);
    });

    int ans = 0;
    vector<int> kok(n);
    for (int i = 0; i < a; i++) {
        ans += x[p[i]];
    }
    for (int i = 0; i < b; i++) {
        ans += y[p[n - 1 - i]];
        kok[p[n - 1 - i]] = 1;
    }
    for (int i = a; i < n - b; i++) {
        ans += max(x[p[i]], y[p[i]]);
        if (y[p[i]] > x[p[i]]) {
            kok[p[i]] = 1;
        }
    }

    cout << ans << '\n';
    for (int i = 0; i < n; i++) cout <<  (kok[i] ? "P" : "T") << ' ';
}

signed main() {
    fast();
    solve();
    return 0;
}
