#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_cxx;
using namespace std;
using namespace __gnu_pbds;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>;

///pragms:

//#pragma GCC optimize("Ofast,O3,unroll-loops")

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native,avx2")

using ull = unsigned long long;
using ll = long long;
using ld = long double;
//using ui = unsigned int;

/*const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new ( size_t n ) {
	char *res = mem + mpos;
	mpos += n;
	assert(mpos <= MAX_MEM);
	return (void *)res;
}
inline void operator delete ( void * ) { }*/

#define int long long

int X(vector <int>& a) {
    int res = 0;
    for (auto& i : a) {
        res ^= i;
    }
    return res;
}

signed main() {
    ios;
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector <int> used(n);
    for (int bit = 62; bit >= 0; --bit) {
        int parity1 = 0, parity2 = 0;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                parity1 ^= (a[i] >> bit & 1);
                parity2 ^= (b[i] >> bit & 1);
            }
        }
        if (parity1 == 0 && parity2 == 0) {
            for (int i = 0; i < n; ++i) {
                if ((a[i] >> bit & 1) != (b[i] >> bit & 1)) {
                    swap(a[i], b[i]);
                    used[i] = 1;
                    break;
                }
            }
        }
    }
    int ans = X(a) + X(b);
    cout << ans << " ";
    vector <int> res;
    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            res.emplace_back(i);
        }
    }
    cout << (int)res.size() << "\n";
    for (auto& i : res) {
        cout << i + 1 << " ";
    }
    return 0;
}


