#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using str = string;
using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;

void solve() {
    int n;
    cin >> n;
    vl a(n), b(n);
    rep(i, n) cin >> a[i];
    rep(i, n) cin >> b[i];
    ll A = 0;
    ll B = 0;
    rep(i, n) A ^= a[i];
    rep(i, n) B ^= b[i];
    vector<ll> bb;
    ll h = 0;
    ll C = A ^B;
    {
        for (ll i = 60; i >= 0; --i) {
            if ((1ll << i) & C) continue;
            bb.push_back(1ll << i);
            h |= (1ll << i);
        }
    }
    vector<ll> c(n);
    rep(i, n) c[i] = a[i] ^ b[i];
    rep(i, n) c[i] &= h;
    const int K = 60;
    vector<ll> gauss(K);
    vector<bitset<maxN>> ids(K);
    for (int i = 0; i < n; ++i) {
        vector<int> xored;
        ll cur = c[i];
        for (int j = K - 1; j >= 0; --j) {
            if (cur & (1ll << j)) {
                if (gauss[j] == 0) {
                    gauss[j] = cur;
                    for (int id : xored)
                        ids[j] = ids[j] ^ ids[id];
                    ids[j][i] = 1;
                    break;
                } else {
                    cur ^= gauss[j];
                    xored.emplace_back(j);
                }
            }
        }
    }
    ll X = A & B;
    bitset<maxN> have;
    for(int j = K - 1; j >= 0; --j) {
        if (gauss[j] == 0) continue;
        if (X & (1ll << j)) continue;
        X ^= gauss[j];
        have ^= ids[j];
    }
    vector<int> res;
    rep(i, n) {
        if (have[i]) {
            A ^= c[i];
            B ^= c[i];
            res.push_back(i + 1);
        }
    }
    cout << A + B << ' ' << res.size() << '\n';
    for(auto &x : res) cout << x << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}