#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using str = string;
using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;

vector<pair<int, ll>> ans;

void go(ll a, ll b) {
    if (a == 0 || b == 0) return;
    if (abs(a) > abs(b)) {
        pair<ll, ll> ku = {INF, INF};
        ll t = a / b;
        for(ll t1 = t - 1; t1 <= t + 1; ++t1) {
            ll g = a - t1 * b;
            ku = min(ku, {abs(g), t1});
        }
        assert(ku.second != 0);
        ans.emplace_back(1, -ku.second);
        a -= b * ku.second;
    } else {
        pair<ll, ll> ku = {INF, INF};
        ll t = b / a;
        for(ll t1 = t - 1; t1 <= t + 1; ++t1) {
            ll g = b - t1 * a;
            ku = min(ku, {abs(g), t1});
        }
        assert(ku.second != 0);
        ans.emplace_back(2, -ku.second);
        b -= a * ku.second;
    }
    go(a, b);
}

void solve() {
    ll a, b; cin >> a >> b;
    go(a, b);
    assert(ans.size() < 50);
    cout << ans.size() << '\n';
    for(auto &[x, y] : ans) cout << x << ' ' << y << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}