#include <iostream>
#include <vector>
#include <cmath>

std::vector<std::vector<int>> arr;
std::vector<int> room;
std::vector<bool> used;
std::vector<int> ans;
int n;

void rec(int nroom, int nch) {
    used[nroom] = true;
    if (room[nroom] >= nch) nch = floor(nch / 2);
    if (nroom == n - 1) ans.push_back(nch);
    for (auto i : arr[nroom]) {
        if (!used[i]) rec(i, nch);
    }
    used[nroom] = false;
}

int main() {
    int m;
    std::cin >> n >> m;
    arr.resize(n);
    room.resize(n);
    used.resize(n, false);

    for (int i = 0; i < m; i++) {
        int f, s;
        std::cin >> f >> s;
        f -= 1;
        s -= 1;
        arr[f].push_back(s);
        arr[s].push_back(f);
    }

    int now;
    std::cin >> now;
    for (int i = 0; i < n; i++) {
        std::cin >> room[i];
    }

    rec(0, now);

    int answer = 0;
    for (auto i : ans) {if (i > answer) answer = i;}

    std::cout << answer;
}
