#include <iostream>
#include <vector>

using namespace std;

int dfs(vector<vector<int>>& v, vector<bool>& visited, vector<int>& d, int pos, int target, int count) {
    //cout << "calling dfs at " << pos << " with " << count << "\n";
    visited[pos] = true;
    if (d[pos] >= count) count = int(count / 2);
    if (pos == target) return count;
    int res = 0;
    for (int i = 0; i < v[pos].size(); i++) {
        if (!visited[v[pos][i]]) {
            res = max(res, dfs(v, visited, d, v[pos][i], target, count));
        }
    }
    //cout << "dfs at " << pos << " returned " << res << "\n";
    return res;
}

int main() {

    int n, m;
    cin >> n >> m;

    vector<vector<int>> v(n, vector<int> (0));
    vector<int> d(n);
    for(int i = 0; i < m; i++) {
        int v1, v2;
        cin >> v1 >> v2;
        v[v1 - 1].push_back(v2 - 1);
        v[v2 - 1].push_back(v1 - 1);
    }

    int x;
    cin >> x;
    for (int i = 0; i < n; i++) {
        cin >> d[i];
    }

    vector<bool> visited(n, false);
    cout << dfs(v, visited, d, 0, n - 1, x);

}
