#include <bits/stdc++.h>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
constexpr int INF = (numeric_limits<int>::max()) / 2;
constexpr long long INFLL = (numeric_limits<long long>::max()) / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int x;
    cin >> x;
    vector<int> a(n);
    cin >> a;
    vector<int> d(n, 0);
    if (x > a[0]) {
        d[0] = x;
    } else {
        d[0] = x / 2;
    }
    set<pair<int, int>> q;
    q.insert({d[0], 0});
    while (!q.empty()) {
        auto [dv, v] = *prev(q.end());
        q.erase(prev(q.end()));
        for (auto u: g[v]) {
            int cur = d[v];
            if (cur <= a[u]) {
                cur /= 2;
            }
            if (d[u] < cur) {
                q.erase({d[u], u});
                d[u] = cur;
                q.insert({d[u], u});
            }
        }
    }
    cout << d[n - 1];
}
