#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stdint.h>
#include <cmath>

using namespace std;

int good(long long i) {
	while (i > 0) {
		if (i % 10 > 3 || i % 10 == 0) {
			return 0;
		}
		i /= 10;
	}
	return 1;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long a, b;
	cin >> a >> b;

	a = sqrt(a);
	b = sqrt(b);
	
	int cnt = 0;
	for (long long i = a; i <= b; i++) {
		cnt += good(i);
	}

	cout << cnt;

	return 0;
}