#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stdint.h>
#include <cmath>
#include <algorithm>

using namespace std;

bool good(long long i) {
	i *= i;
	if (i % 10 == 0)
		return 0;
	long long rev = 0;
	while (i > 0) {
		rev *= 10;
		rev += i % 10;
		i /= 10;
	}
	
	return ((long long)sqrt(rev)*(long long)sqrt(rev) == rev);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long a, b;
	cin >> a >> b;

	a = ceil(sqrt(a));
	b = sqrt(b);
	
	int cnt = 0;
	for (long long i = a; i <= b; i++) {
		cnt += good(i);
	}

	cout << cnt;

	return 0;
}