#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int cnt(string& s) {
    bool ok = false;
    int c = 0;
    for (char& ch : s) {
        if (ch == 'i' || ch == 'a' || ch == 'e' || ch == 'o' || ch == 'u') {
            if (!ok) ++c;
            ok = true;
        } else {
            ok = false;
        }
    }
    return c;
}

bool check(queue<int> q) {
    int c1 = 0;
    while (!q.empty() && c1 < 5) {
        c1 += q.front();
        q.pop();
    }
    int c2 = 0;
    while (!q.empty() && c2 < 7) {
        c2 += q.front();
        q.pop();
    }
    int c3 = 0;
    while (!q.empty() && c3 < 5) {
        c3 += q.front();
        q.pop();
    }
    return (c1 == 5 && c2 == 7 && c3 == 5);
}

void solve() {
    int n;
    cin >> n;
    string s;
    queue<int> q;
    int ss = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        int c = cnt(s);
        q.emplace(c);
        ss += c;
        while (!q.empty() && ss > 17) {
            ss -= q.front();
            q.pop();
        }
        ans += check(q);
    }
    cout << ans;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}