﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>
#include <numeric>

typedef long long ll;
using num = long long;

using namespace std;
/*
int MAX = 20;

vector<pair<bool, ll>> res;

bool recur(int k, int a, int b)
{
    if (k == MAX)
    {
        int result = res.size();
        stringstream s;
        while (a != 0 && b != 0)
        {
            if (abs(a) > abs(b))
            {
                s << "1 " << -(a / b) << '\n';
                a = a % b;
            }
            else
            {
                s << "2 " << -(b / a) << '\n';
                b = b % a;
            }
            ++result;
        }
        if (result > 50)
            return false;
        cout << result << '\n';
        for (int i = 0; i < res.size(); ++i)
        {
            cout << res[i].first << ' ' << res[i].second << '\n';
        }
        cout << s.str();
        return true;
    }
    if (a == 0 || b == 0)
    {
        cout << res.size() << '\n';
        for (int i = 0; i < res.size(); ++i)
        {
            cout << int(res[i].first) + 1 << ' ' << res[i].second << '\n';
        }
        return true;
    }

    int new_a = 0, new_b = 0;
    return false;
}
*/

struct X
{
    num val;
    int ind;

    bool operator< (const X& b) const
    {
        if (val == b.val)
            return ind < b.ind;
        return val > b.val;
    }
};

int main() {
    /*
    ll a, b;
    cin >> a >> b;
    int result = 0;
    stringstream s;
    while (a != 0 && b != 0)
    {
        if (abs(a) > abs(b))
        {
            s << "1 " << -(a / b) << '\n';
            a = a % b;
        }
        else
        {
            s << "2 " << -(b / a) << '\n';
            b = b % a;
        }
        ++result;
    }
    if (result > 50)
        throw(0);
    cout << result << '\n';
    cout << s.str();
    */

    num n, a, b;
    cin >> n >> a >> b;
    vector<num> x(n), y(n);
    for (int i = 0; i < n; ++i)
        cin >> x[i];
    for (int i = 0; i < n; ++i)
        cin >> y[i];
    vector<X> dif(n);
    for (int i = 0; i < n; ++i)
    {
        dif[i].val = x[i] - y[i]; 
        dif[i].ind = i;
    }
    sort(dif.begin(), dif.end());
    vector<char> res(n);
    num result = 0;
    for (int i = 0; i < b; ++i)
    {
        res[dif[n - i - 1].ind] = 'P';
        result += y[dif[n - i - 1].ind];
    }
    for (int i = 0; i < a; ++i)
    {
        res[dif[i].ind] = 'T';
        result += x[dif[i].ind];
    }
    for (int i = a; i < n - b; ++i)
    {
        if (dif[i].val > 0)
        {
            res[dif[i].ind] = 'T';
            result += x[dif[i].ind];
        }
        else
        {
            res[dif[i].ind] = 'P';
            result += y[dif[i].ind];
        }
    }
    cout << result << '\n';
    for (int i = 0; i < n; ++i)
    {
        cout << res[i] << ' ';
    }
    cout << '\n';
    return 0;
}