#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <queue>
#include <stack>
#include <iomanip>
#include <cstdlib>
#include <fstream>
#include <ctime>
#include <random>

#define int long long

using namespace std;

bool check(int n)
{
    if(n % 10 == 0)
        return false;
    int m = 0;
    while(n)
    {
        m = m * 10 + (n % 10);
        n /= 10;
    }
    int k = sqrt(m);
    return k * k == m;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int l, r;
    cin >> l >> r;
    int ans = 0;
    for(int i = 1; i * i <= r; i++)
        ans += (i * i >= l && check(i * i));
    cout << ans;
    return 0;
}
