#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

int get(string s){
    map<char, int> d{{'a', 1},{'e', 1},{'u', 1},{'i', 1},{'o', 1}};
    int flag = 0;
    int ans = 0;
    for (int i = 0; i < s.size(); ++i){
        if (d[s[i]]){
            if (!flag){
                flag = 1;
                ans++;
            }
        } else{
            flag = 0;
        }
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
    cout << fixed;
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif
    int n;
    cin >> n;
    vector<int> sp(n);
    for (int i = 0; i < n; ++i){
        string s;
        cin >> s;
        sp[i] = get(s);
    }
    // for (int &i : sp){
        // cout << i << " ";
    // }
    // cout << '\n';
    vector<int> prefix(n+1);
    prefix[0] = 0;
    for (int i = 1; i <= n; ++i){
        prefix[i] = prefix[i-1] + sp[i-1];
    }
    int ans = 0;
    for (int i = 0; i < n; ++i){
        int r = i+1;
        if (r >= n){
            cout << ans;
            return 0;
        }
        int l = i;
        while (prefix[r] - prefix[l] < 5)
        {
            ++r;
            if (r >= n){
            cout << ans;
            return 0;
        }
        }
        if (prefix[r] - prefix[l] != 5){
            continue;
        }
                // cout << i << "\n";
        l = r;
        r = l+1;
                if (r >= n){
            cout << ans;
            return 0;
        }
        while (prefix[r] - prefix[l] < 7)
        {
            ++r;
                    if (r >= n){
            cout << ans;
            return 0;
        }
        }
        if (prefix[r] - prefix[l] != 7){
            continue;
        }
                // cout << i << "\n";

        l = r;
        r = l+1;
                if (r >= n){
            cout << ans;
            return 0;
        }
        while (prefix[r] - prefix[l] < 5)
        {
            ++r;
                    if (r >= n){
            cout << ans;
            return 0;
        }
        }
        if (prefix[r] - prefix[l] == 5){
                    // cout << i << "\n";
            ans++;
        }
    }
}