#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cmath>
#include <algorithm>
#include <stack>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll BASE = 179;

using namespace std;

typedef long long ll;
typedef long double ld;

ll bp(vector<ll>&v, ll x) {
    ll l = 0, r = v.size();
    while(r - l > 1) {
        ll m = (l + r) / 2;
        if(v[m] >= x)
            l = m;
        else
            r = m;
    }
    return l;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll a, b; cin >> a >> b;
    vector<ll>v;
    for (ll i = 1; i <= 1000000; i++)
        v.push_back(i * i);
    ll ans = 0;
    for(auto i : v) {
        string s;
        s = "";
        ll x = i;
        while(x > 0) {
            ll k = x % 10;
            s += std::to_string(k);
            x /= 10;
        }
        if(s[0] == '0')
            continue;
        ll y = stoll(s);
        if(*lower_bound(v.begin(), v.end(), y) == y) {
            if(i >= a && i <= b) {
                ans++;
            }
        }
    }
    cout << ans;
    return 0;
}