#define _CRT_SECURE_NO_WARNINGS
#define _GLIB_CXX_DEBUG
#define INF 1000000000
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <iomanip>
#include <sstream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define ff first
#define ss second
//#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;

template<typename T>
bool rMin(T& x, const T& y)
{
    if (x > y)
    {
        x = y;
        return true;
    }
    return false;
}
template<typename T>
bool rMax(T& x, const T& y)
{
    if (x < y)
    {
        x = y;
        return true;
    }
    return false;
}


ld X, T;


ld Count(ld x)
{
    if (x <= T/6.0)
    {
        return (6 * X * (T - x)) / T;
    }
    else
    {
        return (X + (x - T / 6.0) * (6.0 * (100 - X) / T)) * (T - x);
//return 6 * (100 - X) * x / T;
  //      return (600 * (T - x) - 6 * (T - x) * X) / T - 2 * X - 100;
    }
}


void solve()
{
    cin >> X >> T;

    ld l = 0, r = T / 2.0;

    while (r - l > 1e-7)
    {
        ld tl = l + (r - l) / 3;
        ld tr = r - (r - l) / 3;

        if (Count(tl) < Count(tr))
        {
            l = tl;
        }
        else
        {
            r = tr;
        }
    }

    cout << Count((l + r) / 2) << endl;
}


int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(6);

    solve();
}