Python 3.9.2 (tags/v3.9.2:1a79785, Feb 19 2021, 13:44:55) [MSC v.1928 64 bit (AMD64)] on win32
Type "help", "copyright", "credits" or "license()" for more information.
>>> if restart != "Y":
        print("It was a pleasure calculating with you!")
        time.sleep(1)
        print("\nGoodbye!")
        time.sleep(1)
        sys.exit()

# Modules:

import time     # Provides time-related functions
import sys      # Used to exit the program when needed


# Operations:

def add(num1, num2):
    #   Returns the sum of num1 and num2
    return num1 + num2


def sub(num1, num2):
    #   Returns the difference of num1 and num2
    return num1 - num2


def mul(num1, num2):
    #   Returns the product of num1 and num2
    return num1 * num2


def div(num1, num2):
    #   Returns the quotient of num1 and num2
    try:
        return num1/num2
    except ZeroDivisionError:
        # Handles division by zero
        print("Division by zero cannot be done. You have broken the universe. Returning zero...")
        return 0


def exp(num1, num2):
    #   Returns the result of num1 being the base and num2 being the exponent
    return num1 ** num2


# Run operational functions:

def run_operation(operation, num1, num2):
    # Determine operationz
    if operation == int("1"):
        print("Adding...\n")
        time.sleep(1)
        print(num1, "+", num2, "=", add(num1, num2))
    elif operation == int("2"):
        print("Subtracting...\n")
        time.sleep(1)
        print(num1, "-", num2, "=", sub(num1, num2))
    elif operation == int("3"):
        print("Multiplying...\n")
        time.sleep(1)
        print(num1, "*", num2, "=", mul(num1, num2))
    elif operation == int("4"):
        print("Dividing...\n")
        time.sleep(1)
        print(num1, "/", num2, "=", div(num1, num2))
    elif operation == int("5"):
        print("Exponentiating...\n")
        time.sleep(1)
        print(num1, "^", num2, "=", exp(num1, num2))
    else:
        print("I don't understand. Please try again.")
        time.sleep(1)


def main():
    while True:                   # Loops if user would like to restart program
        valid_input = False
        while not valid_input:    # Loops if user enters an invalid input. Avoids error
            try:
                # Acquire user input
                num1 = (int(input("What is number 1? ")))
                num2 = (int(input("What is number 2? ")))
                operation = int(input("What would you like to do? \n1. Addition, 2. Subtraction, 3. Multiplication, "4. Division, 5. Exponentiation \nPlease choose an operation: "))
                valid_input = True
            except ValueError:      # Handles any value errors
                print("Invalid input. Please try again.")
                time.sleep(1)
        run_operation(operation, num1, num2)
        time.sleep(1)
        # Ask if the user wants to do more calculations or exit:
        restart = (str(input("Would you like to make more calculations? Enter (Y) for yes, or any other character for no. ")))