#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define int ll

struct Segment {
	int l, r;
	
	const bool operator<(Segment other) {
		return l < other.l;
	};
};

signed main() {
  int n, m;
  cin >> n >> m;
    
	vector<Segment> a(m), b;
	
	for(auto &i : a) {
		cin >> i.l >> i.r;
	}
    
  sort(a.begin(), a.end());
    
	int mid = m / 2, l = mid, r = mid;
	
	Segment x = a[mid];
    
  while (l > 0 && a[l - 1].r >= x.l) {
		l--;
		x.l = min(x.l, a[l].l);
		x.r = max(x.r, a[l].r);
	}
	
	while (r + 1 < m && a[r + 1].l <= x.r) {
		r++;
		x.l = min(x.l, a[l].l);
		x.r = max(x.r, a[l].r);
	}
    
  for (int i = 0; i < l; i++) {
		b.push_back(a[i]);
	}
	mid = (int)b.size();
	b.push_back(x);
	for(int i = r + 1; i < m; i++) {
		b.push_back(a[i]);
	}
	
	m = (int)b.size();
	
	long long ans = 0;
	
	for(int i = mid - 1; i >= 0; i--) {
		if(b[i].r < x.l) {
			ans += (x.l - b[i].r);
			x.l -= (b[i].r - b[i].l);
		}
		else {
			x.l = min(x.l, b[i].l);
			x.r = max(x.r, b[i].r);
		}
	}
    
    for(int i = mid + 1; i < m; i++) {
		if(x.r < b[i].l) {
			ans += (b[i].l - x.r);
			x.r += (b[i].r - b[i].l);
		}
		else {
			x.l = min(x.l, b[i].l);
			x.r = max(x.r, b[i].r);
		}
	}
	
	cout << ans;
    
	cout << endl;
	return 0;
}
