//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,unswitch-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")

#include<bits/stdc++.h>

#define int long long
#define vec vector
#define sz(x) (int)(x.size())
#define f first
#define s second
#define pb push_back
#define endl "\n"
#define pii pair<int, int>
#define all(x) (x).begin(), (x).end()
#define rz resize
#define ld long double
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define rep(i, a, b) for(int i = a ; i < b ; i++)
#define Sum(a) accumulate(all(a), (int)0)
#define psum(a, b) partial_sum(a.begin(), a.end(), b.begin())
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define INF 2e18
#define inf 2e9
///#define int int_fast32_t

using namespace std;

/**

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

*/

template <class T>
istream& operator >> (istream &in, vector<T> &a)
{
    for(auto & i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector<T> &a)
{
    for(auto & i : a)
        out << i << ' ';
    return out;
}

template <class T, class U>
istream& operator >> (istream &in, pair<T, U> &a)
{
    in >> a.f >> a.s;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair<T, U> &a)
{
    out << a.f << ' ' << a.s << endl;
    return out;
}

mt19937 rnd(time(NULL));

#ifdef FelixDzerzhinsky
#define dbg(x) cout << (#x) << "\t" << (x) << endl
#else
#define dbg(x) 238
#endif

void files()
{
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
}

template<typename T1, typename T2>
inline T1 min(T1 a, T2 b)
{
    return (a < b ? a : b);
}

template<typename T1, typename T2>
inline T1 max(T1 a, T2 b)
{
    return (a > b ? a : b);
}

void solve()
{
    int n, m;
    cin >> n >> m;

    vec<vec<int>> g (n);

    FOR(i, m)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;

        g[l].pb(r);
        g[r].pb(l);
    }

    int x;
    cin >> x;

    vec<int> a (n);
    cin >> a;

    auto f = [&](int x, int y)
    {
        if(x > y)
            return x;
        return x / 2;
    };

    vec<int> dp (n, 0);
    vec<int> used (n, 0);
    set<pii> q;

    dp[0] = f(x, a[0]);
    used[0] = 1;
    q.insert({dp[0], 0});

    while(sz(q))
    {
        auto it = q.end();
        it--;
        int v = it->s;
        q.erase({dp[v], v});

        for(auto u : g[v])
        {
            if(dp[u] < f(dp[v], a[u]))
            {
                //q.erase({dp[u], u});
                dp[u] = f(dp[v], a[u]);
                used[u] = 1;
                if(u != n - 1)
                {
                    q.insert({dp[u], u});
                }
            }
        }
    }

    cout << dp.back();
}

signed main()
{
    //fast_io;
    #ifndef FelixDzerzhinsky
        fast_io
        //files
    #endif

    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}
