#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <utility>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <cmath>
#include <random>
#include <ctime>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x) * (x))

const int INF = 1e9, MOD = 1e9 + 7, Q = 38;
const ld eps = 1e-9;
const ll ll_INF = 1e18;
mt19937 gen;


void solve() {
	int n, m, k, n1, m1;
	cin >> n >> m >> k;
	vector<vector<int>> matrix(n, vector<int>(m, 0));
	for (int i = 0, j = 0; i < min(n, m) && j < min(n, m) && k != 0; ++i, ++j) {
		matrix[i][j] = 1;
		k--;
	}
	if (k == 0) {
		cout << "Possible\n";
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; ++j) {
				if (matrix[i][j] == 0) cout << ".";
				else cout << "*";
			}
			cout << "\n";
		}
	}
	else {
		cout << "Impossible";
	}
}


signed main() {
	ios::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	int t = 1;
	//	gen.seed(time(0));
	//	cout << fixed;
	//	cout.precision(15);
	//	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}
