#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>




using namespace std;


tuple<int, int> find_5(int i, int j, vector<int> &dp){

    int x = i - 1; int y = i;

    while (y < j && dp[y] - dp[x] != 5){
        if (dp[y] - dp[x] > 5) x++;
        else{
            y++;
        }
    }

    return {x, y};

}

tuple<int, int> find_7(int i, int j, vector<int> &dp){
    int x = i - 1; int y = i;

    while (y < j && dp[y] - dp[x] < 7){
        y++;
    }

    return {x, y};

}

tuple<int, int> find2_5(int i, int j, vector<int> &dp){
    int x = i - 1; int y = i;

    while (y < j && dp[y] - dp[x] < 5){
        y++;
    }

    return {x, y};

}


int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(16);

    
    int n;
    string st;

    cin >> n;

    //vector<char> c = {«a», «e», «i»,
//«o» и «u»};

    vector<int> v;

    for (int i = 0; i < n; i++){
        cin >> st;
        int cnt = 0, ch = 1;
        for (int j = 0; j < (int) st.size(); j++){            
            if (st[j] == 'a' || st[j] == 'e' || st[j] == 'i' || st[j] == 'o' || st[j] == 'u'){
                if (ch){
                    //cout << st[j] << " ";
                    cnt++;
                    ch = 0;
                }
            }
            else{
                ch = 1;
            }


        }

        v.push_back(cnt);

    }
    int len = (int)v.size();

    vector<int> dp(len + 1, 0);

        
    for (int i = 1; i < len + 1; i++){
        dp[i] = dp[i - 1] + v[i - 1];
    }

    //for (int i = 0; i < len + 1; i++){
        //cout << dp[i] << " ";
    //}

    vector<int> check = {1, 1, 1};

    int x, y, i, j, k, t;

    int cnt = 0;

    
    
    int pos = 1;
    while(true){        
        tie(x, y) = find_5(pos, len + 1, dp);
        pos = x + 2;
        if (dp[y] - dp[x] != 5) break;
        else{
            tie(i, j) = find_7(y + 1, len + 1, dp);
            if (dp[j] - dp[i] > 7) continue;
            else if (dp[j] - dp[i] < 7) break;
            else{
                tie(k, t) = find2_5(j + 1, len + 1, dp);
                if (dp[t] - dp[k] > 5) continue;
                else if (dp[t] - dp[k] < 5) break;
                else cnt++;
            }

        }


    }

    cout << cnt;



        

    



    

    return 0;

    




}