#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <cassert>
#include <cstring>
#include <random>
#include <chrono>
#include <ext/rope>
#include <bitset>

#define sqr(x) ((x) * (x))
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;

template <class T>
using indexed_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
ld Time() { return ld(clock()) / CLOCKS_PER_SEC; }

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    vector<pair<ll, ll>> ans;
    ll a, b;
    cin >> a >> b;
    while (a != 0 && b != 0) {
        if (abs(a) > abs(b)) {
            ll k = a / b;
            if (k > 0) {
                if ( abs(a - k * b) < abs(a - (k + 1) * b) ) {
                    ans.pb({1, -k});
                    a += (-k) * b;
                } else {
                    ans.pb({1, -(k + 1)});
                    a += (-k - 1) * b;
                }
            } else {
                if ( abs(a - k * b) < abs(a - (k - 1) * b) ) {
                    ans.pb({1, -k});
                    a += (-k) * b;
                } else {
                    ans.pb({1, -(k - 1)});
                    a += (-k + 1) * b;
                }
            }
        } else {
            ll k = b / a;
            if (k > 0) {
                if ( abs(b - k * a) < abs(b - (k + 1) * a) ) {
                    ans.pb({2, -k});
                    b += (-k) * a;
                } else {
                    ans.pb({2, -(k + 1)});
                    b += (-k - 1) * a;
                }
            } else {
                if ( abs(b - k * a) < abs(b - (k - 1) * a) ) {
                    ans.pb({2, -k});
                    b += (-k) * a;
                } else {
                    ans.pb({2, -(k - 1)});
                    b += (-k + 1) * a;
                }
            }
        }
    }

    cout << sz(ans) << '\n';
    for (auto x : ans)
        cout << x.fi << ' ' << x.se << '\n';

    return 0;
}