#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    int x;
    cin >> x;
    vector<int> d(n, 0);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    d[0] = x;
    if (a[0] >= x) {
        d[0] >>= 1;
    }
    set<pair<int, int>> best;
    for (int i = 0; i < n; ++i) {
        best.insert(make_pair(-d[i], i));
    }
    while (!best.empty()) {
        int v = best.begin()->second;
        best.erase(best.begin());
        for (int u : g[v]) {
            int val = d[v];
            if (a[u] >= val) {
                val >>= 1;
            }
            if (d[u] < val) {
                best.erase(make_pair(-d[u], u));
                d[u] = val;
                best.insert(make_pair(-d[u], u));
            }
        }
    }
    cout << d[n - 1] << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}