#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    int n, m;
    cin >> n >> m;
    vector<vector<int> > graph(n);
    for(int i = 0; i < m; i++){
        int v, u;
        cin >> v >> u;
        v--; u--;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }
    int x;
    cin >> x;
    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    if(a[0])
        x = x / 2;
    set<pair<int, int> > st;
    vector<int> ans(n, 0);
    ans[0] = x;
    st.insert({x, 0});
    while(!st.empty()){
        auto it = st.end();
        it--;
        x = it -> first;
        st.erase(it);
        int v = it -> second;
        for(int i = 0; i < graph[v].size(); i++){
            int xx = x;
            if(xx <= a[graph[v][i]])
                xx = xx / 2;
            if(xx > ans[graph[v][i]]){
                ans[graph[v][i]] = xx;
                st.insert({xx, graph[v][i]});
            }
        }
    }
    cout << ans.back() << endl;
}
