#include <bits/stdc++.h>
using namespace std;
struct Edge {
    long long v, u;
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, m;
    cin >> n >> m;

    vector<vector<Edge>> graph(n);

    for (long long i = 0; i < m; ++i) {
        long long u, v;
        cin >> u >> v;
        --u; --v;
        graph[u].push_back({u, v});
        graph[v].push_back({v, u});
    }
    vector<long long> dist (n, -1);
    vector<long long> druid (n, -1);

    long long x; cin >> x;
    dist[0] = x;
    for (long long i = 0; i < n; ++i) {
        cin >> druid[i];
    }
    if (dist[0] <= druid[0]) {
        dist[0] = x / 2;
    }
    set<pair<long long, long long>> st;
    st.insert(make_pair(dist[0], 0));
    for (long long i = 0; i < n; ++i) {
        long long v = st.begin()->second;
        st.erase(st.begin());
        for (long long j = 0; j < graph[v].size(); ++j) {
            long long u = graph[v][j].u;
            if (dist[v] > druid[u] && dist[v] > dist[u]) {
                st.erase(make_pair(dist[u], u));
                dist[u] = dist[v];
                st.insert(make_pair(dist[u], u));
            }
            else if (dist[v] <= druid[u] && dist[v] / 2 > dist[u]) {
                st.erase(make_pair(dist[u], u));
                dist[u] = dist[v] / 2;
                st.insert(make_pair(dist[u], u));
            }
        }
    }
    cout << max(dist[n - 1], (long long)0);
    return 0;
}
