#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> ed;
vector<int> a;

#define pb push_back

int dijkstra(int n, int x){
    vector<int> maxclones(n+1);
    priority_queue<pair<int, int>> pq;
    pq.push({x, 1});
    vector<bool> visited(n+1);
    maxclones[1] = x;

    while (!pq.empty()){
        int curx = pq.top().first;
        int cur = pq.top().second;
        pq.pop();

        if (visited[cur]) continue;
        visited[cur] = true;

        for (auto to : ed[cur]){
            if (visited[to]) continue;

            if (maxclones[cur] > a[to]) maxclones[to] = max(maxclones[to], maxclones[cur]);
            else maxclones[to] = max(maxclones[to], maxclones[cur] / 2);

            pq.push({maxclones[to], to});
        }
    }

    return maxclones[n];
}

int main() {
    int n, m; cin >> n >> m;
    ed.resize(n+1);
    for (int i = 0; i < m; ++i){
        int u, v; cin >> u >> v;
        ed[u].pb(v); ed[v].pb(u);
    }
    a.resize(n+1);
    int x; cin >> x;
    for (int i = 1; i <= n; ++i) cin >> a[i];

    if (x <= a[1]) x /= 2;

    int ans = dijkstra(n, x);
    cout << ans << "\n";

    return 0;
}
