#include <bits/stdc++.h>

#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("sse,sse2,sse3,ssse3,abm,mmx,avx,avx2,popcnt,tune=native")

using namespace std;

#define F first
#define S second
#define pb push_back
#define pushf push_front
#define popb pop_back
#define popf pop_front
#define vec vector
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
//#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef map<ll, ll> mll;
typedef map<string, string> msl;

const ll inf = 1e18;
const ll maxn = 250;
const ll mod = 1e9 + 7;
const ll P = 239;
const ld PI = 3.14159265358979323846;
const double eps = 1e-8;
ll m, k, n;
char ch;
bool ok = true;

vec<vec<ll>> gr;
vec<ll> used, dp, a;

ll check(ll kol, ll v) {
    if (kol > a[v]) return kol;
    return kol / 2;
}

void dfs(ll v) {
    used[v] = 1;
    for (ll to: gr[v]) {
        if (dp[to] < check(dp[v], to)) {
            dp[to] = check(dp[v], to);
            dfs(to);
        }
    }
    /*
    for (ll i: dp) cout << i << " ";
    cout << endl;
     */
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(12);
    cin >> n >> m;
    gr.resize(n);
    used.resize(n);
    dp.resize(n);
    for (ll i = 0; i < m; ++i) {
        ll x, y;
        cin >> x >> y;
        gr[x - 1].pb(y - 1);
        gr[y - 1].pb(x - 1);
    }
    ll x;
    cin >> x;
    a.resize(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];
    dp[0] = check(x, 0);
    dfs(0);
    if (!used[n - 1]) cout << 0;
    else cout << dp[n - 1];
    return 0;
}