#include <algorithm>
#include <cmath>
#include <iostream>
#include <set>
#include <string>
#include <vector>

using namespace std;
using ll = long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  int n, a, b;
  cin >> n >> a >> b;

  vector<int> c(n), d(n);
  for (int i = 0; i < n; i++)
    cin >> c[i];
  for (int i = 0; i < n; i++)
    cin >> d[i];

  vector<bool> ans(n);

  int total = 0, cnt1 = 0, cnt2 = 0;
  for (int i = 0; i < n; i++) {
    if (c[i] > d[i]) {
      cnt1++;
      ans[i] = false;
      total += c[i];
    } else {
      cnt2++;
      ans[i] = true;
      total += d[i];
    }
  }

  if (cnt1 >= a && cnt2 >= b) {
  } else {
    vector<pair<int, int>> e(n);
    for (int i = 0; i < n; i++)
      e[i].first = abs(c[i] - d[i]), e[i].second = i;

    sort(e.begin(), e.end());
    int curr = 0;
    while (cnt1 < a) {
      while (ans[e[curr].second] != true)
        curr++;

      cnt1++, cnt2--, total = total - d[e[curr].second] + c[e[curr].second];
      ans[e[curr].second] = false;
    }
    while (cnt2 < b) {
      while (ans[e[curr].second] != false)
        curr++;

      cnt1--, cnt2++, total = total + d[e[curr].second] - c[e[curr].second];
      ans[e[curr].second] = true;
    }
  }

  cout << total << '\n';
  for (int i = 0; i < n; i++)
    if (ans[i])
      cout << "P ";
    else
      cout << "T ";
}