﻿#pragma GCC target ("avx2")

#include <iostream>
#include <vector>
#include <list>
#include<algorithm>
#include<iterator>
#include<string>
#include<set>
using namespace std;
const int N = 3e5 + 7;
const long long INF = 1e18;

struct pr {
	long long first;
	int second;
};

long long n, f, i, b, m, q, c, j, V, A;
long long  a[N];

vector<int > edges[N];
int p[N];
long long d[N];
set <pr> SET;
pr M;
bool operator<(pr a, pr b) {
	if (a.first == b.first) {
		return a.second > b.second;
	}
	return a.first > b.first;
}



void Dijkstra() {
	for (int i = 1; i <= n; i++) {
		SET.insert({ d[i],i });
	}
	for (i = 0; i < n; i++) {
		M = *SET.begin();
		for (j = 0; j < edges[M.second].size(); j++) {
			int u = edges[M.second][j];
			if (a[u] > M.first) {
				if (d[u] < M.first / 2) {
					SET.erase({ d[u], u });
					d[u] = M.first / 2;
					SET.insert({ d[u],u });
				}
			}
			else {
				if (d[u] < M.first) {
					SET.erase({ d[u], u });
					d[u] = M.first;
					SET.insert({ d[u],u });
				}
			}
		}
		SET.erase(M);
	}
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	for (i = 0; i < N; i++) {
		d[i] = -1*INF;
		a[i] = -1*INF;
	}

	cin >> n >> m;

	for (i = 0; i < m; i++) {
		cin >> A >> b;
		edges[A].push_back( b );
		edges[b].push_back( A);
	}
	long long h;
	cin >> h;
	d[1] = h;
	
		for (int i = 1; i <= n; i++) {
			cin >> a[i];
		}
		if (a[1] > d[1]) {
			d[1] /= 2;
		}
	Dijkstra();

	cout << max(d[n],0LL);
	return 0;
}