#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <string>
using namespace std;

#define ins insert
#define int long long
#define VI vector<int>
#define VVI vector<VI>
#define foriab(i, a, b) for(int i=(a);i<(b);++i)
#define fori(i, n) foriab(i, 0, n)
#define foris(i, n) foriab(i, 0, n.sz())
#define sz size
#define pb push_back
#define VSI vector<SI>
#define SI set<int>
#define x first
#define y second


int rmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

int rmax(int& a, int b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
istream& operator>>(istream& input, vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		input >> v[i];
	}
	return input;
}

template<class T>
ostream& operator<<(ostream& output, vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		output << v[i] << ' ';
	}
	return output;
}

bool is_vowel(char c) {
	return c == 'a' || c == 'e' || c == 'o' || c == 'u' || c == 'i';
}

int sylabels(const string& str) {
	int cnt = 0;
	for (int i = 0; i < str.size(); ++i) {
		if (is_vowel(str[i])) {
			cnt++;
			while (i < str.size() && is_vowel(str[i])) i++;
		}
	}
	return cnt;
}


string reverse(string s) {
	reverse(s.begin(), s.end());
	return s;
}
int PWR;
int power(int bum){
	return PWR>>(bum);
}
signed main(){
	int n, m;
	cin>>n>>m;
	VVI g(n);
	fori(i, m){
		int a, b;
		cin>>a>>b;
		--a;--b;
		g[a].pb(b);
		g[b].pb(a);
	}
	cin>>PWR;
	VI pwr(n);
	cin>>pwr;
	VI used(n);
	set<pair<int, int>> op;
	op.ins({0, 0});
	VI d(n, 1000);
	if(pwr[0]>=PWR){
		d[0]=1;
	}
	else {
		d[0] = 0;
	}
	while(op.sz()){
		int who=op.begin()->y;
		op.erase(op.begin());
		if(used[who]){
			continue;
		}
		used[who]=1;
		for(int u:g[who]){
			int ye=pwr[u]>=power(d[who]);
			if(rmin(d[u], d[who]+ye)){
				op.ins({d[u], u});
			}
		}
	}
	cout<<power(d[n-1])<<endl;
}
