#include <iostream>
#include <vector>
#include <set>
using namespace std;
#include <random>


int tries = 0;
vector <vector<int>> bannedFrom;
vector <pair<bool, int>> yes;


bool check(int l, int r) {
	for (int i = 0; i < bannedFrom[l].size(); i++)

		if (bannedFrom[l][i] == r)
			return true;
	return false;
}


pair <int, int> found() {
	int l = 0, r = tries;
	int cnt = 0;
	if (!yes[l].first)
		cnt++;

	while (check(l, r)) {
		l++;
	}

	return make_pair(l, r);
}

int main()
{
	long long n;
	cin >> n;
	bannedFrom.resize(n);
	yes.resize(n);
	for (int i = 0; i < n; i++) {
		yes[i] = make_pair(false, 0);
	}
	for (int i = 0; i < n; i++) {
		auto ans = found();
		cout << "? " << ans.first + 1 << " " << ans.second + 1 << "\n";
		long long a, b, sum;

		cin >> sum >> a >> b;
		bannedFrom[a - 1].push_back(b - 1);

		int need;
		for (int i = ans.first; i <= ans.second; i++)
			if (yes[i].first)
				sum -= yes[i].second;
			else
				need = i;
		yes[need].second = sum;
		yes[need].first = true;
		tries++;
	}

	cout << "!\n";
	for (int i = 0; i < n; i++)
		cout << yes[i].second << " ";

	return 0;
}