#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld

using namespace std;

const int inf = 1e9;
const ll INF = 1e18;

const int maxn = 1e5;

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n), b(n);
    for (auto & e : a)
        cin >> e;
    for (auto & e : b)
        cin >> e;
    bitset<maxn + 1> swapped;

    ll xa = 0, xb = 0;

    for (auto & e : a)
        xa ^= e;
    for (auto & e : b)
        xb ^= e;

    vector<ll> diff(n + 1);
    for (int i = 1; i <= n; ++i)
        diff[i] = (a[i - 1] ^ b[i - 1]);

    ll global = xa ^ xb;

    vector<pair<ll, ll>> dp(n + 1, {xa, xb});
    vector<int> pr(n + 1, -1);

    for (int i = 1; i <= n; ++i) {
        for (int p = 0; p < i; ++p) {
            if ((dp[p].x ^ diff[i]) + (dp[p].y ^ diff[i]) > dp[i].x + dp[i].y) {
                dp[i] = {(dp[p].x ^ diff[i]), (dp[p].y ^ diff[i])};
                pr[i] = p;
            }
        }
    }

    for (int cur = n; pr[cur] != -1; cur = pr[cur])
        swapped[cur] = true;

    cout << dp[n].x + dp[n].y << " " << swapped.count() << endl;
    for (int i = 1; i <= n; ++i)
        if (swapped[i])
            cout << i << " ";
    cout << endl;

}

signed main() {

#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    cout.precision(16);

    solve();
}
