#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld

using namespace std;

const int inf = 1e9;
const int INF = 1e18;

pair<int, pair<int, int>> ask(int l, int r) {
    cout << "? " << l + 1 << " " << r + 1 << endl;

    int a, b, c;
    cin >> a >> b >> c;
    return {a, {b - 1, c - 1}};
}

void reply(vector<int> & arr) {
    cout << "!" << endl;
    for (int i : arr)
        cout << i << " ";
}

void solve() {
    int n, a, b;
    cin >> n >> a >> b;

    vector<int> x(n), y(n);
    for (int & e : x)
        cin >> e;
    for (int & e : y)
        cin >> e;

    vector<int> indexes(n);
    iota(all(indexes), 0);

    sort(all(indexes), [&](int a, int b) {return x[a] - y[a] > x[b] - y[b];});

    string s(n, '.');
    int ans = 0;
    for (int i = 0; i < a; ++i) {
        ans += x[indexes[i]];
        s[indexes[i]] = 'T';
    }

    for (int i = 0; i < b; ++i) {
        ans += y[indexes[n - 1 - i]];
        s[indexes[n - 1 - i]] = 'P';
    }

    for (int i = a; i + b < n; ++i) {
        ans += max (x[indexes[i]], y[indexes[i]]);
        if (x[indexes[i]] > y[indexes[i]])
            s[indexes[i]] = 'T';
        else
            s[indexes[i]] = 'P';
    }
    cout << ans << endl;
    for (char ch : s)
        cout << ch << ' ';
}

signed main() {

#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL


    solve();
}
