#define _CRT_SECURE_NO_WARNINGS

#ifndef _DEBUG
#include<bits/stdc++.h>
#endif

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <deque>
#include <bitset>

typedef long long ll;
#define endl '\n'
#define mp make_pair
#define pb push_back

using namespace std;

using ld = long double;

const int N = 2e5;

ll a[N];
ll b[N];

bitset<N> y[65];
int l[N];
bool used[N];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	fill(l, l + N, -1);
	int n;
	cin >> n;
	ll all = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		all ^= a[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		b[i] ^= a[i];
	}
	ll ans = 0;
	for (int bit = 60; bit >= 0; bit--)
	{
		for (int i = 0; i < n; i++)
		{
			y[bit][i] = (b[i] & (1LL << bit));
		}
		y[bit][n] = !(all & (1LL << bit));
		int lpos = -1;
		for (int i = n - 1; i >=0; i--)
		{
			if (y[bit][i])
			{
				if (l[i] != -1)
				{
					y[bit] ^= y[l[i]];
				}
				else
				{
					lpos = i;
					break;
				}
			}
		}
		if (lpos != -1)
		{
			l[lpos] = bit;
		}
		if (lpos == -1 && y[bit][n])
			continue;
		else
			ans += (1LL << bit);
	}
	all = 0;
	for (int i = 0; i < n; i++)
	{
		all ^= b[i];
	}
	cout << ans + (all ^ ans) << " ";
	vector<int> pos;
	for (int i = 0; i < n; i++)
	{
		if (l[i] != -1)
		{
			int t = 0;
			for (int j = 0; j < n; j++)
			{
				t ^= used[j];
			}
			used[i] = t ^ y[l[i]][n];
			if (used[i])
				pos.push_back(i + 1);
		}
	}
	cout << pos.size() << endl;
	for (auto i : pos)
	{
		cout << i << " ";
	}
}