#include <iostream>
#include <vector>
#include <deque>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;


int f(int k, int d){
    if (k <= d){
        k /= 2;
    }
    return k;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n, m, a, b;
    cin >> n >> m;
    vector<vector<int>> hodi(n);
    for (int i = 0; i < m; i++){
        cin >> a >> b;
        hodi[a - 1].push_back(b - 1);
        hodi[b - 1].push_back(a - 1);
    }
    vector<int> klon(n, 0);
    cin >> klon[0];
    vector<int> droid(n, 0);
    for (int i = 0; i < n; ++i){
        cin >> droid[i];
    }
    klon[0] = f(klon[0], droid[0]);
    deque<int> q;
    q.push_back(0);
    while (q.size() > 0){
//        for (int el: q){
//            cout << el << ' ';
//        }
//        cout << '\n';
        a = q.back();
        q.pop_back();
        for (int el : hodi[a]){
            int x = f(klon[a], droid[el]);
            if (x > klon[el]){
                klon[el] = x;
                q.push_front(el);
            }
        }
    }
    cout << klon[n - 1];

    return 0;
}
