#include <iostream>
#include <iomanip>
#include <string>
#include <set>
#include <queue>
#include <map>
#include <vector>
#include <climits>
#include <algorithm>

using namespace std;

const int INF = 1e9 + 7;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n, m, k;
    cin >> n >> m >> k;
    if (min(n, m) >= k)
    {
        cout << "Possible" << endl;
        vector<vector<char> > a(n, vector<char>(m, '.'));
        for (int i = 0; i < k; i++)
        {
            a[i][i] = '*';
        }
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < m; j++)
            {
                cout << a[i][j];
            }
            cout << endl;
        }
    }
    else
        cout << "Impossible" << endl;
    return 0;
}