#include <algorithm>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
  cin.tie(nullptr);
  cout.tie(nullptr);
  ios::sync_with_stdio(false);
  cin.exceptions(ios::failbit);
}

inline void solve() noexcept {
  int n,m,k;
  cin >> n >> m >> k;
  if(k > max(n,m)){
    cout << "Impossible" << endl;
    return;
  }
  vector <vector <char> > a(n, vector <char> (m, '.'));
  cout << "Possible" << endl;
  for (int i = 0; i < min({n,m,k}); ++i){
      a[i][i] = '*';
  }
  for (int i = 0; i < n; ++i){  
    for (int j = 0; j < m; ++j)
      cout << a[i][j];
    cout << endl;
  }
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  fastio();
  int tt = 1;
  // cin >> tt;
  while (tt-- > 0)
    solve();
  return 0;
}
