#include <iostream>
#include <deque>

const long long maxN = 100000;
long long n, m, s[maxN], t[maxN], dp[maxN], dp1[maxN], ans;
std::deque<std::pair<long long, long long>> d;

int main() {
    std::cin >> n >> m;
    for (long long i = 0; i < m; i++) {
        std::cin >> s[i] >> t[i];
        s[i]--;
        t[i]--;
    }
    for (long long i = s[0] - 1; i >= 0; i--)
        dp[i] = dp[i + 1] + 1;
    for (long long i = t[0] + 1; i < n; i++)
        dp[i] = dp[i - 1] + 1;
    for (long long i = 1; i < m; i++) {
        d.clear();
        for (long long j = s[i]; j <= t[i]; j++) {
            while (!d.empty() && d.back().first >= dp[j])
                d.pop_back();
            d.push_back({ dp[j], j });
        }
        for (long long j = s[i]; j <= t[i]; j++)
            dp1[j] = d.front().first;
        for (long long j = t[i] + 1, h = s[i]; j < n; j++, h++) {
            while (!d.empty() && d.back().first >= dp[j])
                d.pop_back();
            d.push_back({ dp[j], j });
            if (d.front().second == h)
                d.pop_front();
            dp1[j] = d.front().first + j - t[i];
        }
        d.clear();
        for (long long j = t[i]; j >= s[i]; j--) {
            while (!d.empty() && d.back().first >= dp[j])
                d.pop_back();
            d.push_back({ dp[j], j });
        }
        for (long long j = s[i] - 1, h = t[i]; j >= 0; j--, h--) {
            while (!d.empty() && d.back().first >= dp[j])
                d.pop_back();
            d.push_back({ dp[j], j });
            if (d.front().second == h)
                d.pop_front();
            dp1[j] = d.front().first + s[i] - j;
        }
        d.clear();
        for (long long j = 0; j < s[i]; j++) {
            while (!d.empty() && d.back().first >= dp[j] + s[i] - j)
                d.pop_back();
            d.push_back({ dp[j] + s[i] - j, j });
            if (d.front().second == j - (t[i] - s[i] + 1))
                d.pop_front();
            dp1[j] = std::min(dp1[j], d.front().first);
        }
        d.clear();
        for (long long j = n - 1; j > t[i]; j--) {
            while (!d.empty() && d.back().first >= dp[j] + j - t[i])
                d.pop_back();
            d.push_back({ dp[j] + j - t[i], j });
            if (d.front().second == j + (t[i] - s[i] + 1))
                d.pop_front();
            dp1[j] = std::min(dp1[j], d.front().first);
        }
        for (long long j = 0; j < n; j++)
            dp[j] = dp1[j];
    }
    ans = dp[0];
    for (long long i = 1; i < n; i++)
        ans = std::min(ans, dp[i]);
    std::cout << ans;
    return 0;
}