#include <bits/stdc++.h>

using namespace std;
using u64 = unsigned long long;
using s64 = long long;
using u32 = unsigned int;
using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int> >;
using pii = pair<int, int>;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define all(a) (a).begin(), (a).end()

const int INF = 1e9;

struct segtree {
    int N;
    vi tree;
    segtree(const vi& arr) {
        int n = arr.size();
        N = n + 10;
        tree.assign(2*N, INF);
        for (int i = 0; i < n; ++i) {
            tree[N+i] = arr[i];
        }
        for (int i = N-1; i > 0; --i) {
            tree[i] = min(tree[i*2], tree[i*2 + 1]);
        }
    }
    int ask(int l, int r) {
        r++;
        l += N;
        r += N;
        int res = INF;
        while (l < r) {
            if (l & 1) res = min(res, tree[l++]);
            if (r & 1) res = min(res, tree[--r]);
            l >>= 1;
            r >>= 1;
        }
        return res;
    }
};

void solve(istream& cin, ostream& cout) {
    int n, m;
    cin >> n >> m;
    vvi dp(m, vi(n, INF));
    vi arr(n, 0); segtree tree(arr);
    int prev = n;
    forn(i, m) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int len = r-l+1;
        forn(j, n-len+1) {
            dp[i][j] = tree.ask(max((int)0, j-prev+1), min((int)n-1, j+len-1)) + abs(j-l);
        }
        tree = segtree(dp[i]);
        prev = len;
    }
    cout << tree.ask(0, n) << '\n';
}

int32_t main(){
    //ifstream cin("in.txt");
    //ofstream cout("out.txt");
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve(cin, cout);
    }
    return 0;
}
