#include <bits/stdc++.h>

using namespace std;
#define int long long
using u64 = unsigned long long;
using s64 = long long;
using u32 = unsigned int;
using ld = long double;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int> >;
using pii = pair<int, int>;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define all(a) (a).begin(), (a).end()


void solve(istream& cin, ostream& cout) {
    int a, b;
    cin >> a >> b;
    queue<tuple<int, int, int, vector<pii> > > q;
    if (a > b) {
        q.push({a, b, 0, {}});
    } else {
        q.push({b, a, 1, {}});
    }
    while (!q.empty()) {
        int a, b, type;
        vector<pii> past;
        tie(a, b, type, past) = q.front(); q.pop();
        if (b == 0) {
            cout << past.size() << '\n';
            for (auto& x : past) cout << x.first+1 << ' ' << x.second << '\n';
            return;
        }
        int k = -a/b;
        // + 0
        past.emplace_back(type, k);
        q.push({b, a + k*b, 1-type, past});
        past.pop_back();
        // + 1
        past.emplace_back(type, k+1);
        q.push({b, a + (k+1)*b, 1-type, past});
        past.pop_back();
        // - 1
        past.emplace_back(type, k-1);
        q.push({b, a + (k-1)*b, 1-type, past});
        past.pop_back();
    }
}


int32_t main(){
    //ifstream cin("in.txt");
    //ofstream cout("out.txt");
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve(cin, cout);
    }
    return 0;
}
