//@author: Kirkon

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <stack>
#include <chrono>
#include <cstdio>
#include <cstdlib>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>


//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, avx2, tune=native")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef float ff;
typedef double lf;
typedef long double llf;

const double eps = 1e-6;
const int int_inf = 2 * 1e9;
const ll ll_inf = 8 * 1e18;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto& i : a) {
        out << a;
    }
    return out;
}

template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
    return (ull)rng() % B;
}

ll phin(ll n) { ll number = n; if (n % 2 == 0) { number /= 2; while (n % 2 == 0) n /= 2; } for (ll i = 3; i * i <= n; i += 2) { if (n % i == 0) { while (n % i == 0)n /= i; number = (number / i * (i - 1)); } } if (n > 1)number = (number / n * (n - 1)); return number; } //O(sqrt(N))

llf X, T;

llf f(llf k0){
    return (X + (100 - X) * k0 * 6 / T) * (5 * T / 6 - k0);
}

void solve(){
    
    cin >> X >> T;
    cout.precision(60);
    llf ans = 0;
    ans = max(ans, 5*T/6 * X);
    llf val3 = 5 * T / 6 * X;
    ans = max(ans, 2 * T / 3 * 100);
    //llf k0 = (6 * X - 500) / (12 * X - 1200) * T;
    //llf k0 = T/6;
    //llf val = (X + (100 - X) * k0 * 6 / T) * (5 * T / 6 - k0);
    llf l = 0, r = T / 6;
    while(r - l > 1e-8){
        llf m1 = l + (r - l) / 3;
        llf m2 = r - (r - l) / 3;
        if(f(m1) < f(m2)){
            l = m1;
        }else{
            r = m2;
        }
    }
    ans = max(ans, f(l));
    //ans = max(ans, (X + (100 - X) * k0 * 6 / T) * (5 * T / 6 - k0));
    cout << ans;
    return;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    solve();
    return 0;
}
